package de.ipk.pdwExpress.curator;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.List;

import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuBar;
import javax.swing.JPanel;

import org.apache.commons.configuration.ConfigurationException;
import org.apache.commons.configuration.PropertiesConfiguration;
import org.apache.log4j.Logger;

import com.l2fprod.common.swing.JTaskPaneGroup;
import com.l2fprod.common.swing.JTaskPane;


import de.ipk.pdwExpress.curator.images.AppImages;
import de.ipk.pdwExpress.curator.images.ImageHandler;
import de.ipk.pdwExpress.curator.tasks.CuratorActions;
import de.ipk.pdwExpress.curator.tasks.DefaultCuratorAction;
import de.ipk.pdwExpress.curator.tasks.MenuBarBuilder;
import de.ipk.pdwExpress.curator.tasks.SysActions;
import de.ipk.pdwExpress.curator.util.CuratorToolKit;
import de.ipk.pdwExpress.curator.view.database.LoginDialog;
import de.ipk.pdwExpress.curator.view.statusbar.IStatusBar;
import de.ipk.pdwExpress.curator.view.statusbar.StatusBarImpl;
import de.ipk.pdwExpress.curator.view.titlepanel.ITitlePanel;
import de.ipk.pdwExpress.curator.view.titlepanel.TitlePanelImpl;
import de.ipk.pdwExpress.ols.connection.IOlsDao;
import de.ipk.pdwExpress.ols.connection.OlsDaoImpl;

public class CuratorApp {

	protected final Logger logger;

	private JFrame jFrame = null;  //  @jve:decl-index=0:visual-constraint="7,41"

	private JPanel jContentPane = null;

	private JMenuBar jMenuBar = null;

//	private IEditPanelGUI editPanelView;  //  @jve:decl-index=0:

	private JComponent taskBar;  //  @jve:decl-index=0:

	private IStatusBar statusBar;

	private ITitlePanel titlePanel;

	private JPanel contentPanel;

	private static Connection connection;

	private SysActions sysActions;
	private CuratorActions curatorActions;
	
	private static IOlsDao olsDao;

//	private String version="";

	public CuratorApp(){
		logger = Logger.getLogger(this.getClass());
	}


	private void init(){
		List<DefaultCuratorAction> curator = getCuratorActions().getCurators();
		
		for (DefaultCuratorAction action : curator) {
			action.getCurator().initiate();
		}


	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

//		BasicConfigurator.configure();

		CuratorApp application = new CuratorApp();
		application.getJFrame().setVisible(true);
		application.getStatusBar().setProgressIndeterminate(true);
//		application.getJFrame().setEnabled(false);
		application.getStatusBar().setStatus("Creating connection.");
		application.createConnection();
		application.init();
//		application.getJFrame().setEnabled(true);
		application.getStatusBar().setProgressIndeterminate(false);
		application.getStatusBar().setStatus("Connection created.");






//		SwingUtilities.invokeLater(new Runnable() {
//			public void run() {
////				String log ="E:/development/projects/topLevel/pdwExpress/pdwExpress-curator/src/main/java/log4j.properties";
////				String log ="log4j.properties";
////				URL url = application.getClass().getResource(log);
////				System.out.println("URL for logging properties " +url);
////				if (url != null)
////					PropertyConfigurator.configure ( "log44j.properties" ) ;
//
//
////				EditPanelViewImpl ep = new EditPanelViewImpl();
//				//Curator cr = new CuratorTestImpl();
////				Curator cr = new AccessionCurator();
////				EditPanelControl ec= new EditPanelControl(ep,cr);
////				ec.init();
////				application.setMainPanel(ep);
////
//
//			}
//		});
	}

//	protected IEditPanelGUI getEditPanelView(){
//		if (editPanelView == null){
//			editPanelView = new EditPanelGUIImpl();
//		}
//
//		return editPanelView;
//	}

	
	private JMenuBar getJMenuBar() {
		if (jMenuBar == null){
			MenuBarBuilder m =new MenuBarBuilder(getSysActions(),getCuratorActions());
			jMenuBar = m.getJMenuBar();
		}
		return jMenuBar;
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout(10,20));
			jContentPane.add(getTaskBar(),BorderLayout.WEST);
			jContentPane.add((StatusBarImpl)getStatusBar(),BorderLayout.SOUTH);
			jContentPane.add(getContentPanel(),BorderLayout.CENTER);
		}
		return jContentPane;
	}

	private void showTitlePanel(boolean showTitlePanel){
		if (showTitlePanel)
			getContentPanel().add((Component) getTitlePanel(), BorderLayout.NORTH);
		else
			getContentPanel().add(new JLabel());
	}

	private JComponent getTaskBar() {
		if (taskBar == null){
			 // a container to put all JTaskPaneGroup together
			 JTaskPane taskPaneContainer = new JTaskPane();

			 JTaskPaneGroup taskReplacements = new JTaskPaneGroup();
			 taskReplacements.setTitle("Replacements");
			 taskReplacements.add(getSysActions().getReplacementOverViewAction());
			 taskReplacements.add(getSysActions().getNewReplacementAction());
			 taskReplacements.add(getSysActions().getSaveReplacementAction());
//			 taskReplacements.add(getSysActions().getReplacementOverViewAction());

			 JTaskPaneGroup taskCuratos = new JTaskPaneGroup();
			 taskCuratos.setSpecial(true);
			 taskCuratos.setTitle("Curatos");

			 List<DefaultCuratorAction> curators = getCuratorActions().getCurators();
			 for (DefaultCuratorAction action : curators) {
				taskCuratos.add(action);
     		 }

//			 taskCuratos.add(getCuratorActions().getEmptyCuratorAction());
//			 taskCuratos.add(getCuratorActions().getAccessionCuratorAction());
//			 taskCuratos.add(getCuratorActions().getAgeCuratorAction());
//			 taskCuratos.add(getCuratorActions().getOrganismPartCuratorAction());
//			 taskCuratos.add(getCuratorActions().getUnrefDuplicateCurator());

			 JTaskPaneGroup taskSys = new JTaskPaneGroup();
			 taskSys.setTitle("Sys");
			 taskSys.add(getSysActions().getExitAction());

			 taskPaneContainer.setBackground(new JLabel().getBackground());
			 taskPaneContainer.add(taskReplacements);
			 taskPaneContainer.add(taskCuratos);
			 taskPaneContainer.add(taskSys);

			 taskBar=taskPaneContainer;
		}
		return taskBar;
	}

	private JPanel getContentPanel() {

		if (contentPanel ==null){
			contentPanel = new JPanel(new BorderLayout(10,10));
		}
		return contentPanel;
	}

	private ITitlePanel getTitlePanel() {
		if (titlePanel==null){
			titlePanel= new TitlePanelImpl();
		}
		return titlePanel;
	}

	private void createConnection(){

		String propertiesFile ="application.properties";
		PropertiesConfiguration config = new PropertiesConfiguration();
		InputStream in = getClass().getResourceAsStream("/"+propertiesFile);

		if (in == null)
			logger.fatal(propertiesFile+" inputstream is null");

		try {
			config.load(in , null);
		} catch (ConfigurationException e) {
			logger.fatal("Error while reading "+propertiesFile);
			e.printStackTrace();
		}

		String driverClass = config.getString("database.driverClass");
		String server = config.getString("database.server");
		String port = config.getString("database.port");
		String database = config.getString("database.databaseName");

		String dbUser = config.getString("database.dbUser");
		String pwd = config.getString("database.dbPwd");
		
		if (dbUser == null || pwd == null){
			LoginDialog dialog = new LoginDialog(this.jFrame);
			dialog.setUserName(dbUser);
			dialog.setPassword(pwd);			
			CuratorToolKit.centerFrame(dialog);
			dialog.setModal(true);
			dialog.setVisible(true);
			pwd=dialog.getPassword();
			dbUser=dialog.getUserName();
		}		

		String connectString = "jdbc:oracle:thin:@"+ server+ ":"+ port+ ":"+ database;

		try {
			connection=createConnection(driverClass,connectString,dbUser,pwd);
		}catch(Exception ex){
			System.err.println(ex);
		}
	}

	private Connection createConnection(String driverClass,String connectString, String dbUser, String dbPassWord ) throws SQLException, ClassNotFoundException{

		Connection con=null;
		try {
        	logger.debug("Loading driver:"+driverClass);
			Class.forName(driverClass);

			logger.debug("Connecting to DB. "+connectString);
			con = DriverManager.getConnection(connectString , dbUser, dbPassWord);

			logger.info("Connection created.");

		} catch (SQLException e) {
			logger.error(e);
			e.printStackTrace();
			throw new SQLException(e.toString());
		} catch (ClassNotFoundException e) {
			logger.error(e);
			e.printStackTrace();
			throw new ClassNotFoundException(e.toString());
		}
		return con;
	}
	
//	protected String getVersion() {
//		return version;
//	}
	

	public final static Connection getConnection() {
		return connection;
	}
	
	public SysActions getSysActions() {
		if (sysActions==null){
			sysActions = new SysActions(this);
		}
		return sysActions;
	}


	public CuratorActions getCuratorActions() {
		if (curatorActions==null){
			curatorActions = new CuratorActions(this);
		}
		return curatorActions;
	}

	public IStatusBar getStatusBar() {
		if (statusBar ==null){
			statusBar = new StatusBarImpl();
		}
		return statusBar;
	}	

	/**
	 * This method initializes jFrame
	 *
	 * @return javax.swing.JFrame
	 */
	public JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new JFrame();
			jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			jFrame.setJMenuBar(getJMenuBar());
			jFrame.setContentPane(getJContentPane());
			jFrame.setTitle("PDWExpress Curator");
			jFrame.setSize(1100, 800);
			ImageIcon icon = ImageHandler.getImageIcon(AppImages.EDIT);
			if (icon != null)
				jFrame.setIconImage(icon.getImage());

			CuratorToolKit.centerFrame(jFrame);
			jFrame.setExtendedState(Frame.MAXIMIZED_BOTH);

		}
		return jFrame;
	}
	
	public void setTitlePanelAction(Action a){
		getTitlePanel().setAction(a);
		showTitlePanel(true);
	}
	
	public void setMainPanel(JPanel pan){
		setMainPanel(pan,null);
	}

	/**
	 * Set the Visible Panel
	 * @param pan The Panel.
	 * @param action An action to create the TitelPanel
	 */
	public void setMainPanel(JPanel pan,Action action){
		getContentPanel().removeAll();
		getContentPanel().add(pan, BorderLayout.CENTER);
		setTitlePanelAction(action);
	}


	public final static IOlsDao getOlsDao() throws SQLException {
		if (olsDao == null)
				olsDao= new OlsDaoImpl(getConnection());

		return olsDao;
	}
}
