package de.ipk.pdwExpress.curator.control;

import java.util.Date;

import de.ipk.pdwExpress.persistence.model.EditingSession;
import de.ipk.pdwExpress.persistence.model.Replacement;

public class ReplacementFactory {
	
	private static final ReplacementFactory replacementFactory = new ReplacementFactory();
	private ReplacementFactory(){
		createNewReplacement();
	};
	
	private static Replacement currentReplacement;
	private static EditingSession editingSession;
	
	
	/**
	 * The actually edited Replacement
	 * @return
	 */
	public static Replacement getCurrentReplacement(){
		return currentReplacement;
	}
	
	/**
	 * Notice the given replacement and creates a new EditSession.
	 * 
	 * @see getCurrentReplacement()
	 * @see getCurrentEditingSession()
	 * @param newReplacement
	 */
	public static void setCurrentReplacement(Replacement newReplacement){
		currentReplacement=newReplacement;
		createNewEditingSession();
	}	
	
	/**
	 * Creates a new Replacement
	 * @return
	 */
	public static Replacement createNewReplacement(){
		
		Replacement newRpl=new Replacement();
		newRpl.setRplCreationdate(new Date());
		newRpl.setRplAuthor(System.getProperty("user.name"));
		currentReplacement=newRpl;
		
		createNewEditingSession();
		
		return getCurrentReplacement();
	}
	
	
	/**
	 * 
	 * @return The Session for insering Term.
	 */
	public static EditingSession getCurrentEditingSession(){
		return editingSession;
	}
	
	private static EditingSession createNewEditingSession() {
		EditingSession newESE = new EditingSession();
		newESE = new EditingSession();
		newESE.setEseUsername(System.getProperty("user.name"));
		newESE.setEseImportdate(new Date());
		newESE.setEseSourceDesc("CuratorTool");
		// editingSession.setEseDesc("");
		newESE.setEseSuccessful('n');
		
		editingSession=newESE;
		
		return newESE;
	}

}
