package de.ipk.pdwExpress.curator.control.overview;

import java.util.List;
import java.util.Vector;

import javax.swing.table.AbstractTableModel;

import org.apache.log4j.Logger;

import de.ipk.pdwExpress.persistence.model.Replacement;

public class RplOverviewTableModel extends AbstractTableModel {

	protected Logger logger;
	private List<Replacement> dataVector = new Vector<Replacement>(0);
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static final Vector<String> columnIdentifiers = new Vector<String>(4);
	
	static{
		columnIdentifiers.add("ID");
		columnIdentifiers.add("Creation date");
		columnIdentifiers.add("Author");
		columnIdentifiers.add("Description");
	}

	public RplOverviewTableModel(){
		logger = Logger.getLogger(this.getClass());
	}
	
	public void setDataVector(List<Replacement> dataVector) {
		this.dataVector=dataVector;
		fireTableDataChanged();
	}

	public int getColumnCount() {
		return 4;
	}

	public int getRowCount() {
		return dataVector.size();
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		switch (columnIndex) {
		case 0:
			return dataVector.get(rowIndex).getRplId();
		case 1:
			return dataVector.get(rowIndex).getRplCreationdate();
		case 2:
			return dataVector.get(rowIndex).getRplAuthor();
		case 3:
			return dataVector.get(rowIndex).getRplDesc();
		default:
			logger.warn("Column not found. columnIndex:"+columnIndex);
			return null;
		}
	}

	@Override
	public String getColumnName(int column) {
		return columnIdentifiers.get(column);
	}

	public List<Replacement> getDataVector() {
		return dataVector;
	}
	
	
	
}
