package de.ipk.pdwExpress.curator.curator;

import java.util.List;
import java.util.Vector;

import javax.swing.JPanel;

import org.apache.log4j.Logger;

import de.ipk.pdwExpress.persistence.model.Term;
import de.ipk.pdwExpress.persistence.model.TrmReplace;

public abstract class AbstractCurator implements ICurator {

	protected Logger logger;
	
	public AbstractCurator(){
		logger = Logger.getLogger(this.getClass()); 
	}
	
	public List<Term> getTermsToEdit() {
		return new Vector<Term> (5);
	}

	
	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.curator.ICurator#transformTerm(de.ipk.pdwExpress.persistence.model.Term)
	 */
	public TrmReplace transformTerm(Term termSource) {
		return getEmptyTrmReplace(termSource);
	}
	
	/**
	 * @return An 'empty' TrmReplace.  <code>termSource</code> set as source, no target;
	 */
	public static TrmReplace getEmptyTrmReplace(Term termSource){
		TrmReplace rpl = new TrmReplace();
		rpl.setSourceTerm(termSource);
		return rpl;		
	}
	
	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.curator.ICurator#getSuccessfulLoadedMessage()
	 */
	public String getSuccessfulLoadedMessage(){
		return "Data of curator '"+getName()+"' successful loaded.";
	}
	
	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.curator.ICurator#close()
	 */
	public void close(){
	}
	
	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.curator.ICurator#getConfigPanel()
	 */
	public JPanel getConfigPanel(){
		return null;
	}
	

	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.curator.ICurator#initiate()
	 */
	public void initiate(){
	}
	

}
