package de.ipk.pdwExpress.curator.curator;

import java.util.List;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import de.ipk.pdwExpress.curator.CuratorApp;
import de.ipk.pdwExpress.persistence.dataAccess.ExternDbDAO;
import de.ipk.pdwExpress.persistence.dataAccess.TermDAO;
import de.ipk.pdwExpress.persistence.dataAccess.TrmCategoryDAO;
import de.ipk.pdwExpress.persistence.model.ExternDB;
import de.ipk.pdwExpress.persistence.model.Term;
import de.ipk.pdwExpress.persistence.model.TrmCategory;
import de.ipk.pdwExpress.persistence.model.TrmReplace;

public class AgeCurator extends AbstractCurator  {
	
//	private final static String REGEX_VALUE="([\\d]*\\u0046?,?[\\d]*)";
//	private final static String REGEX_UNIT="(days|day|d|weeks|week|months|month)?";
//	private final static String REGEX_EXT="(.*)";

	
//	private TrmCategory catTimeUnit ;
//	private TrmCategory catAge;
	private TrmCategory catAgeValue;
	private TrmCategory catAgeRefrence;
	private ExternDB edbUnref;
	

	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.curator.AbstractCurator#getTermsToEdit()
	 */
	@Override
	public List<Term> getTermsToEdit() {
	
		List<Term> allTerms;
		
		TermDAO tDao = new TermDAO();
		allTerms= tDao.getByCategoryName("Age",CuratorApp.getConnection());

		return allTerms;
	}

	
	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.curator.ICurator#initiate()
	 */
	@Override
	public void initiate(){
		
	
		TrmCategoryDAO tctDao = new TrmCategoryDAO();
		
		List<TrmCategory> cats;
//		cats = tctDao.getByName("Age"); 
//		if (!cats.isEmpty())
//			catAge=cats.get(0);
		
//		cats = tctDao.getByName("TimeUnit"); 
//		if (!cats.isEmpty())
//			catTimeUnit=cats.get(0);
		
		cats = tctDao.getByName("AgeReference",CuratorApp.getConnection()); 
		if (!cats.isEmpty())
			catAgeRefrence=cats.get(0);
		
		cats =tctDao.getByName("AgeValue",CuratorApp.getConnection()); 
		if (!cats.isEmpty())
			catAgeValue=cats.get(0);		
		
		List<ExternDB> edbs;
		ExternDbDAO edbDAO = new ExternDbDAO();
		edbs = edbDAO.getByName("unreferenced",CuratorApp.getConnection()); 
		if (!edbs.isEmpty())
			edbUnref=edbs.get(0);
		
	}
	


	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.curator.AbstractCurator#transformTerm(de.ipk.pdwExpress.persistence.model.Term)
	 */
	@Override
	public TrmReplace transformTerm(Term termSource) {
		
		TrmReplace tr = new TrmReplace();
		tr.setSourceTerm(termSource);
	
		
		List<Term> destinationTerms = new Vector<Term>();
		
//		Pattern p = Pattern.compile("([\\d]*\\u0046?,?[\\d]*)\\s*(days|day|d|weeks|week|months|month)?\\s*(.*)"); 
		Pattern p = Pattern.compile("([\\d]*\\u0046?,?[\\d]*)\\s*(days|day|d|weeks|week|months|month|hours|hour|h)?\\s*(.*)");
		Matcher m = p.matcher(termSource.getTrmValue().trim());
		
		
		
		if (m.matches()){
			
			String value = m.group(1);
			String unit = m.group(2);
			String ageRef = m.group(3);			
				
			// value
			Term tValue = new Term();
			tValue.setTrmValue(value.replace(',', '.'));
			tValue.setTrmCategory(catAgeValue);
			tValue.setExterndb(edbUnref);
			
			// TODO
			if (tValue.getTrmValue() != null && tValue.getTrmValue().trim().length()!=0)
				destinationTerms.add(tValue);
			
			// unit
			if (m.groupCount() >=2){
				Term tUnit;
				tUnit = getTimeUnitTerm(unit);
				if (tUnit != null)
					destinationTerms.add(tUnit);
			}
			
			// extension
			if (m.groupCount() >=2 && ageRef.length()>0){
				Term tExtension = new Term();
				tExtension.setTrmCategory(catAgeRefrence);
				tExtension.setTrmValue(ageRef);
				tExtension.setExterndb(edbUnref);
				
				if (tExtension.getTrmValue() != null && tExtension.getTrmValue().trim().length()!=0)
					destinationTerms.add(tExtension);
			}
			
			tr.setDestinationTerms(destinationTerms);
		}
		
		return tr;
	}
	
	/**
	 * 
	 * @param trmValue
	 * @return The Term which represents the given timeUnit
	 */
	private Term getTimeUnitTerm(String trmValue){
		logger.debug("Searching for TimeUnit:"+trmValue);
		
		if (trmValue == null)
			return null;
		
		TermDAO termDAO = new TermDAO();
		List<Term> terms = termDAO.getByCatagoryNameAndValue("TimeUnit",mapUnit(trmValue),CuratorApp.getConnection());
		
		if (!terms.isEmpty()){
			logger.debug("found:"+terms.get(0)+".");
			return terms.get(0);
		}
		else {
			logger.debug("found nothing.");
			return null;
		}		
	}
	
	/**
	 * Converts the given unit <br>
	 * Example: intput 'd', output 'days' 
	 * @param unit
	 * @return
	 */
	private String mapUnit(String unit){
		String newUnit = unit.trim();
		
		if ("d".equalsIgnoreCase(newUnit))
			newUnit="days";
		else if ("day".equalsIgnoreCase(newUnit))
			newUnit="days";	
		else if ("week".equalsIgnoreCase(newUnit))
			newUnit="weeks";
		else if ("hour".equalsIgnoreCase(newUnit))
			newUnit="hours";
		else if ("h".equalsIgnoreCase(newUnit))
			newUnit="hours";		
		
		return newUnit;
	}

	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.curator.ICurator#getName()
	 */
	public String getName() {
		return "Age Curator";
	}

	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.curator.ICurator#getShortDescription()
	 */
	public String getShortDescription() {
		return "Searches for term where category is 'Age'.";
	}

}
