package de.ipk.pdwExpress.curator.curator;

import java.sql.SQLException;
import java.util.List;
import java.util.Vector;

import de.ipk.pdwExpress.curator.CuratorApp;
import de.ipk.pdwExpress.persistence.dataAccess.ExternDbDAO;
import de.ipk.pdwExpress.persistence.dataAccess.TermDAO;
import de.ipk.pdwExpress.persistence.model.ExternDB;
import de.ipk.pdwExpress.persistence.model.Term;
import de.ipk.pdwExpress.persistence.model.TrmReplace;

public class OrganismPartCurator extends AbstractCuratorUsingOls{

//	private Map <String, ExternDB> edbMap = new HashMap <String, ExternDB>();
	
	
	public OrganismPartCurator(){
	}
	
	/**
	 * 
	 */
	@Override
	public List<Term> getTermsToEdit() {
	
		List<Term> allTerms;
		
		TermDAO tDao = new TermDAO();
		allTerms= tDao.getTermsWithoutAccession("OrganismPart",CuratorApp.getConnection());

		return allTerms;
	}

	@Override
	public TrmReplace transformTerm(Term termSource) {
		
		TrmReplace rpl = getEmptyTrmReplace(termSource);
		ExternDbDAO edbDAO = new ExternDbDAO();
		
		try {
			List<Term> terms ;

			/*
			 * Versuch 1: muss genau passen
			 */
			terms =getOlsDaoImpl().getTermsByValue(termSource.getTrmValue());
			for (Term t: terms){
				logger.debug("old"+t.getExterndb());
				ExternDB edb = edbDAO.synchronizeByShortName(t.getExterndb(),CuratorApp.getConnection());
				
				if (edb == null){
					logger.warn("Databases does not exists. Term ignored. term:"+t);
					continue;
				}
				t.setExterndb(edb);
				t.setTrmCategory(termSource.getTrmCategory());
				logger.debug("new"+t.getExterndb());
			}
			

			/*
			 * Versuch 2: plural
			 */
			if ((terms == null || terms.isEmpty())){
				
				String defaultTerm= termSource.getTrmValue();
				String searchTerm =null;

				// TODO use Oracle text function 
				
				if (defaultTerm.equalsIgnoreCase("leaves")) 
					searchTerm = "leaf";
				else if (defaultTerm.endsWith("ies"))
					searchTerm = defaultTerm.substring(0, defaultTerm.length() - 1) + "y";
				else if (defaultTerm.endsWith("s"))
					searchTerm = defaultTerm.substring(0, defaultTerm.length() - 1);
				
					
				if (searchTerm != null){
				
					logger.debug("defaultTerm:"+defaultTerm+ "  searchTerm:"+searchTerm);		
					
					terms =getOlsDaoImpl().getTermsByValue(searchTerm);
					
					for (Term t: terms){
						logger.debug("old"+t.getExterndb());
						ExternDB edb = edbDAO.synchronizeByShortName(t.getExterndb(),CuratorApp.getConnection());
						
						if (edb == null){
							logger.warn("Databases does not exists. Term ignored. term:"+t);
							continue;
						}
						t.setExterndb(edb);
						t.setTrmCategory(termSource.getTrmCategory());
						logger.debug("new"+t.getExterndb());
					}
				}
			}
			
			
			
			List<Term> destinationTerms = new Vector<Term>();
			destinationTerms.addAll(terms);
			rpl.setDestinationTerms(destinationTerms );
			
			
		} catch (SQLException e) {
			logger.error(e.toString());
			e.printStackTrace();
		}
		return rpl;
	}
	
	
	public String getShortDescription() {
		return "1) Searches for all Terms of category 'OrganismPart' without accession. 2) Searches for TrmValue in OLS.";
	}

	public String getName() {
		return "OrganismPart Curator";
	}

}
