package de.ipk.pdwExpress.curator.curator;

import java.util.List;

import de.ipk.pdwExpress.curator.CuratorApp;
import de.ipk.pdwExpress.persistence.dataAccess.TermDAO;
import de.ipk.pdwExpress.persistence.model.Term;
import de.ipk.pdwExpress.persistence.model.TrmReplace;

public class UnrefDuplicateCurator extends AbstractCurator {

	

	public String getName() {
		return "Unref. duplicates Curator";
	}

	public String getShortDescription() {
		return "Searches for Term values which exits more than one time. Maps the unreferenced Term to the referenced one.";
	}

	@Override
	public List<Term> getTermsToEdit() {

//		select * from terms_t
//		where trm_value in (
//		    select trm_value from terms_t 
//		    group by trm_value
//		    having count (trm_value) > 1
//		) and trm_edb_id = 0
		
		
		TermDAO dao = new TermDAO();
		List<Term> terms = dao.getBySQLWhere("  trm_value in ("+
												" select trm_value from terms_t "+
												" group by trm_value, trm_tct_id"+
												" having count (trm_value) > 1"+
												") and trm_edb_id = 0",CuratorApp.getConnection());
		
		return terms;
	}

	@Override
	public TrmReplace transformTerm(Term termSource) {
		
		TrmReplace trl = getEmptyTrmReplace(termSource);
		
		TermDAO dao = new TermDAO();
		List<Term> terms = dao.getBySQLWhere("  trm_value = '"+termSource.getTrmValue()+"' and trm_edb_id <> 0",CuratorApp.getConnection());

//		List<Term> destinationTerms = new Vector<Term>(terms);
		trl.setDestinationTerms(terms);

		return trl;
	}
	
	

}
