package de.ipk.pdwExpress.curator.images;

import java.awt.Toolkit;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.net.URL;

import javax.swing.ImageIcon;

import org.apache.log4j.Logger;

public class ImageHandler {

	static Logger logger = Logger.getLogger("de.ipk.pdwExpress.curator.images.ImageHandler");

	/**
	 * source: http://java.sun.com/docs/books/tutorial/uiswing/components/icon.html#getresource
	 * 
	 * @param path
	 * @param description
	 * @return
	 */
	protected static ImageIcon createAppletImageIcon(String path,String description) {
		
		int MAX_IMAGE_SIZE = 75000; // Change this to the size of your biggest image, in bytes.
		int count = 0;
		BufferedInputStream imgStream = new BufferedInputStream(ImageHandler.class.getResourceAsStream(path));
		
		if (imgStream != null) {
			
			byte buf[] = new byte[MAX_IMAGE_SIZE];
			
			try {
				count = imgStream.read(buf);
			} catch (IOException ieo) {
				logger.error("Couldn't read stream from file: " + path);
				return null;
			}

			try {
				imgStream.close();
			} catch (IOException ieo) {
				System.err.println("Can't close file " + path);
				return null;
			}

			if (count <= 0) {
				logger.error("Empty file: " + path);
				return null;
			}
			return new ImageIcon(Toolkit.getDefaultToolkit().createImage(buf),description);
		} else {
			logger.error("Couldn't find file: " + path);
			return null;
		}
	}
	
	public static ImageIcon getImageIcon(AppImages img) {

		URL url = ImageHandler.class.getResource(img.getName());
		
//		InputStream is = ImageHandler.class.getResourceAsStream( "/test.properties" );
		

//		if (url != null) {
//			ImageIcon i = new ImageIcon(url);
		ImageIcon i=createAppletImageIcon("/"+img.getName(),null);
			if (i == null)
				logger.warn("Image not found. " + img.getName());
			return i;
//		}
//		logger.warn("ImageResource not found. " + img.getName());
//
//		return null;

	}
}
