package de.ipk.pdwExpress.curator.tasks;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JPanel;

import de.ipk.pdwExpress.curator.CuratorApp;
import de.ipk.pdwExpress.curator.control.editpanel.EditPanelControl;
import de.ipk.pdwExpress.curator.curator.ICurator;
import de.ipk.pdwExpress.curator.images.AppImages;
import de.ipk.pdwExpress.curator.images.ImageHandler;
import de.ipk.pdwExpress.curator.util.SwingWorker;

public class DefaultCuratorAction extends AbstractAction {

	
	private static final long serialVersionUID = 1L;
	public static final String LARGE_ICON="LARGE_ICON";
	private final ICurator curator ;
	private CuratorApp curatorApp;
	
	private final EditPanelControl ec;
//	private final IEditPanelGUI editPanelView;
		
	
	
	public DefaultCuratorAction(CuratorApp curatorApp,EditPanelControl ec,ICurator cr){
		this.curator=cr;
		
		this.ec=ec;
//		this.editPanelView=ec.getEditPanel();
		this.curatorApp=curatorApp;
		
		
		putValue(Action.SMALL_ICON,ImageHandler.getImageIcon(AppImages.EDIT));
		putValue(DefaultCuratorAction.LARGE_ICON,ImageHandler.getImageIcon(AppImages.EDIT24));
		putValue(Action.SHORT_DESCRIPTION,cr.getShortDescription());
		putValue(Action.NAME,cr.getName() );
	}


	public void actionPerformed(ActionEvent e) {

		
		curatorApp.getStatusBar().setProgressIndeterminate(true);
		final DefaultCuratorAction _this = this;
		
		final SwingWorker sw = new SwingWorker(){

			@Override
			public Object construct() {

//				EditPanelControl ec= new EditPanelControl(editPanelView,curator,curatorApp);
				ec.init(curator);	
				return null;
			}

			@Override
			public void finished() {
				curatorApp.setMainPanel((JPanel) ec.getEditPanel(),_this);
				curatorApp.getStatusBar().setProgressIndeterminate(false);
				curatorApp.getStatusBar().setStatus(curator.getSuccessfulLoadedMessage());					
			}
		};
		sw.start();
	}
	
	public ICurator getCurator() {
		return curator;
	}


}
