package de.ipk.pdwExpress.curator.tasks;

import java.util.List;

import javax.swing.JMenu;
import javax.swing.JMenuBar;

public class MenuBarBuilder {
	
	private final JMenuBar menuBar = new JMenuBar();
	private final CuratorActions curatorActions;
	private final SysActions sysActions;
	
	public MenuBarBuilder(SysActions sysActions,CuratorActions curatorActions){
		this.curatorActions=curatorActions;
		this.sysActions=sysActions;
		initDefaultMenueBar();
	}

	public JMenuBar getJMenuBar() {
		return menuBar;
	}
	
	private void initDefaultMenueBar(){
		JMenu mSys = new JMenu("File");
		mSys.add(sysActions.getExitAction());
		
		JMenu mCuratos = new JMenu("Curators");
		
		 List<DefaultCuratorAction> curators = curatorActions.getCurators();
		 for (DefaultCuratorAction action : curators) {
			 mCuratos.add(action);
 		 }
		 
//		mCuratos.add(curatorActions.getAccessionCuratorAction());
//		mCuratos.add(curatorActions.getAgeCuratorAction());
//		mCuratos.add(curatorActions.getEmptyCuratorAction());
//		mCuratos.add(curatorActions.getOrganismPartCuratorAction());
		
		JMenu mReplacement = new JMenu("Replacements");
		mReplacement.add(sysActions.getReplacementOverViewAction());
		mReplacement.add(sysActions.getSaveReplacementAction());
		mReplacement.add(sysActions.getNewReplacementAction());
				
		JMenu mHelp = new JMenu("Help");
		mHelp.add(sysActions.getAboutAction());
		
		menuBar.add(mSys);
		menuBar.add(mCuratos);
		menuBar.add(mReplacement);
		menuBar.add(mHelp);
	}

}
