package de.ipk.pdwExpress.curator.view.database;

import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import de.ipk.pdwExpress.curator.images.AppImages;
import de.ipk.pdwExpress.curator.images.ImageHandler;
import de.ipk.pdwExpress.curator.view.titlepanel.TitlePanelImpl;

public class LoginDialog extends JDialog {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JLabel jLabel = null;

	private JLabel lblPassword = null;

	private JTextField txtUserName = null;

	private JPasswordField txtPwd = null;

	private TitlePanelImpl bannerPanel = null;

	private JButton bnLogin = null;

	private JButton bnCancel = null;

	private JLabel dummy = null;
	

	public String getPassword() {
		return new String(getTxtPwd().getPassword()).trim();
	}

	public String getUserName() {
		return getTxtUserName().getText().trim();
	}
	
	public void setPassword(String password) {
		getTxtPwd().setText(password);
	}

	public void setUserName(String userName) {
		getTxtUserName().setText(userName);
	}

	/**
	 * @param owner
	 */
	public LoginDialog(Frame owner) {
		super(owner);
		initialize();
		getRootPane().setDefaultButton(getBnLogin());
		pack();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(303, 185);
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 0;
			gridBagConstraints6.fill = GridBagConstraints.BOTH;
			gridBagConstraints6.ipadx = 0;
			gridBagConstraints6.ipady = 0;
			gridBagConstraints6.weightx = 10.0D;
			gridBagConstraints6.weighty = 10.0D;
			gridBagConstraints6.gridwidth = 4;
			gridBagConstraints6.gridy = 6;
			dummy = new JLabel();
			dummy.setText("");
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 3;
			gridBagConstraints5.anchor = GridBagConstraints.SOUTHEAST;
			gridBagConstraints5.insets = new Insets(12, 0, 12, 12);
			gridBagConstraints5.gridy = 5;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 1;
			gridBagConstraints4.anchor = GridBagConstraints.SOUTHEAST;
			gridBagConstraints4.weightx = 1.0D;
			gridBagConstraints4.insets = new Insets(12, 0, 12, 6);
			gridBagConstraints4.gridy = 5;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints3.gridwidth = 4;
			gridBagConstraints3.insets = new Insets(0, 0, 12, 0);
			gridBagConstraints3.gridy = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints2.gridy = 3;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.gridwidth = 3;
			gridBagConstraints2.insets = new Insets(6, 6, 0, 12);
			gridBagConstraints2.gridx = 1;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints11.gridy = 2;
			gridBagConstraints11.weightx = 1.0;
			gridBagConstraints11.gridwidth = 4;
			gridBagConstraints11.insets = new Insets(6, 6, 0, 12);
			gridBagConstraints11.gridx = 1;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.insets = new Insets(6, 12, 0, 0);
			gridBagConstraints1.gridy = 3;
			lblPassword = new JLabel();
			lblPassword.setText("Password");
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new Insets(6, 12, 0, 0);
			gridBagConstraints.gridy = 2;
			jLabel = new JLabel();
			jLabel.setText("UserName");
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(jLabel, gridBagConstraints);
			jContentPane.add(lblPassword, gridBagConstraints1);
			jContentPane.add(getTxtUserName(), gridBagConstraints11);
			jContentPane.add(getTxtPwd(), gridBagConstraints2);
			jContentPane.add(getBannerPanel(), gridBagConstraints3);
			jContentPane.add(getBnLogin(), gridBagConstraints4);
			jContentPane.add(getBnCancel(), gridBagConstraints5);
			jContentPane.add(dummy, gridBagConstraints6);
		}
		return jContentPane;
	}

	/**
	 * This method initializes txtUserName	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTxtUserName() {
		if (txtUserName == null) {
			txtUserName = new JTextField(25);
		}
		return txtUserName;
	}

	/**
	 * This method initializes txtPwd	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */
	private JPasswordField getTxtPwd() {
		if (txtPwd == null) {
			txtPwd = new JPasswordField(25);
		}
		return txtPwd;
	}

	/**
	 * This method initializes bannerPanel	
	 * 	
	 * @return com.jidesoft.dialog.BannerPanel	
	 */
	private TitlePanelImpl getBannerPanel() {
		if (bannerPanel == null) {
			bannerPanel = new TitlePanelImpl();
			bannerPanel.setTitle("Login");
			bannerPanel.setDescription("Please insert username and password.");
			bannerPanel.setIcon(ImageHandler.getImageIcon(AppImages.LOGIN));
		}
		return bannerPanel;
	}

	/**
	 * This method initializes bnLogin	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBnLogin() {
		if (bnLogin == null) {
			bnLogin = new JButton();
			bnLogin.setText("Login");
			bnLogin.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					dispose();
				}
			});
		}
		return bnLogin;
	}

	/**
	 * This method initializes bnCancel	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBnCancel() {
		if (bnCancel == null) {
			bnCancel = new JButton();
			bnCancel.setText("Cancel");
			bnCancel.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					System.exit(0);
				}
			});
		}
		return bnCancel;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
