package de.ipk.pdwExpress.curator.view.editpanel;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.Vector;

import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.DefaultCellEditor;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.ListCellRenderer;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import de.ipk.pdwExpress.curator.view.editors.SelectTermTableCellEditor;
import de.ipk.pdwExpress.curator.view.editors.TrmCategoryEditor;
import de.ipk.pdwExpress.curator.view.renderer.ExternDBListCellRenderer;
import de.ipk.pdwExpress.curator.view.renderer.TrlTypeListCellRenderer;
import de.ipk.pdwExpress.curator.view.viewPanel.ViewPanelGUIImpl;
import de.ipk.pdwExpress.persistence.model.ExternDB;
import de.ipk.pdwExpress.persistence.model.TrlType;
import de.ipk.pdwExpress.persistence.model.TrmCategory;
import de.ipk.pdwExpress.persistence.model.TrmCategoryTree;

public class EditPanelGUIImpl extends ViewPanelGUIImpl implements IEditPanelGUI,ListSelectionListener{

	private static final long serialVersionUID = 1L;

	private JButton bnAddDest = null;
	private JButton bnRemoveDest = null;
	private JButton bnAddSource = null;
	private JButton bnRemoveSource = null;	
	private SelectTermTableCellEditor termEditor;
	protected final TrmCategoryEditor trmCategoryEditor = new TrmCategoryEditor();
	protected final ListCellRenderer externDBListCellRenderer= new ExternDBListCellRenderer();  //  @jve:decl-index=0:	
	protected final ListCellRenderer trlTypeistCellRenderer = new TrlTypeListCellRenderer();
	protected final DefaultComboBoxModel cboModelTrlType = new DefaultComboBoxModel();

	private JComboBox cboReplaceType = null;
	
	/**
	 * This is the default constructor
	 */
	public EditPanelGUIImpl() {
		super();
		initialize();
	}
	

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.removeAll();
		GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
		gridBagConstraints12.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints12.gridy = 2;
		gridBagConstraints12.gridheight=1;
		gridBagConstraints12.gridwidth=1;
		gridBagConstraints12.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints12.weightx = 10.0D;
		gridBagConstraints12.anchor = GridBagConstraints.NORTHWEST;
		gridBagConstraints12.gridx = 0;
		GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
		gridBagConstraints21.gridx = 2;
//		gridBagConstraints21.weightx=0;
		gridBagConstraints21.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints21.anchor = GridBagConstraints.EAST;
		gridBagConstraints21.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints21.gridy = 2;
		GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
		gridBagConstraints11.gridx = 1;
		gridBagConstraints11.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints11.anchor = GridBagConstraints.EAST;
		gridBagConstraints11.weightx = 40.0D;
		gridBagConstraints11.fill = GridBagConstraints.NONE;
		gridBagConstraints11.gridy = 2;
		GridBagConstraints gridBagConstraints4 = new GridBagConstraints();//
		gridBagConstraints4.gridx = 4;
		gridBagConstraints4.anchor = GridBagConstraints.EAST;
		gridBagConstraints4.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints4.gridy = 2;
		gridBagConstraints4.weightx = 0;
		GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
		gridBagConstraints31.gridx = 3;
		gridBagConstraints31.anchor = GridBagConstraints.EAST;
		gridBagConstraints31.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints31.weightx = 50.0D;
		gridBagConstraints31.fill = GridBagConstraints.NONE;
		gridBagConstraints31.gridy = 2;
		GridBagConstraints gridBagConstraintsScrollSource = new GridBagConstraints();
		gridBagConstraintsScrollSource.fill = GridBagConstraints.BOTH;
		gridBagConstraintsScrollSource.gridy = 1;
//		gridBagConstraintsScrollSource.weightx = 50;
		gridBagConstraintsScrollSource.weighty = 1.0;
		gridBagConstraintsScrollSource.gridx = 0;
		gridBagConstraintsScrollSource.gridheight=1;
		gridBagConstraintsScrollSource.gridwidth=3;
		gridBagConstraintsScrollSource.insets = new Insets(0, 10, 0, 0);
		GridBagConstraints gridBagConstraintsScrollDest = new GridBagConstraints();
		gridBagConstraintsScrollDest.fill = GridBagConstraints.BOTH;
		gridBagConstraintsScrollDest.gridy = 1;
//		gridBagConstraintsScrollDest.weightx = 50;
		gridBagConstraintsScrollDest.weighty = 1.0;
		gridBagConstraintsScrollDest.gridx = 3;
		gridBagConstraintsScrollDest.gridwidth=2;
		gridBagConstraintsScrollDest.insets = new Insets(0, 10, 0, 0);
		GridBagConstraints gridBagConstraintsLblDest = new GridBagConstraints();
		gridBagConstraintsLblDest.gridy = 0;
		gridBagConstraintsLblDest.anchor = GridBagConstraints.WEST;
		gridBagConstraintsLblDest.insets = new Insets(0, 10, 6, 0);
		gridBagConstraintsLblDest.gridx = 3;
		gridBagConstraintsLblDest.gridwidth=2;
		gridBagConstraintsLblDest.weightx = 50;//
		GridBagConstraints gridBagConstraintsLblSource = new GridBagConstraints();
		gridBagConstraintsLblSource.gridy = 0;
		gridBagConstraintsLblSource.gridwidth=3;
		gridBagConstraintsLblSource.anchor = GridBagConstraints.WEST;
		gridBagConstraintsLblSource.insets = new Insets(0, 10, 6, 0);
		gridBagConstraintsLblSource.gridx = 0;
		gridBagConstraintsLblSource.weightx = 50;//
//		jLabel1 = new JLabel();
//		jLabel1.setText("Destination");
//		jLabel = new JLabel();
//		jLabel.setText("Source");
		this.setLayout(new GridBagLayout());
		this.setSize(504, 330);
		this.setBorder(BorderFactory.createEmptyBorder(6, 6, 6, 6));
		this.add(lblSource, gridBagConstraintsLblSource);
		this.add(lblDest, gridBagConstraintsLblDest);
		
		this.add(getScrollDest(), gridBagConstraintsScrollDest);
		this.add(getScrollSource(), gridBagConstraintsScrollSource);
		
		this.add(getCboReplaceType(), gridBagConstraints12);
		this.add(getBnAddSource(), gridBagConstraints11);
		this.add(getBnRemoveSource(), gridBagConstraints21);
		
		this.add(getBnAddDest(), gridBagConstraints31);
		this.add(getBnRemoveDest(), gridBagConstraints4);
		
		
		
	}

	

	/**
	 * This method initializes bnAddDest	
	 * 	
	 * @return javax.swing.JButton	
	 */
	protected JButton getBnAddDest() {
		if (bnAddDest == null) {
			bnAddDest = new JButton();
			bnAddDest.setText("Add");
		}
		return bnAddDest;
	}

	/**
	 * This method initializes bnRemoveDest	
	 * 	
	 * @return javax.swing.JButton	
	 */
	protected JButton getBnRemoveDest() {
		if (bnRemoveDest == null) {
			bnRemoveDest = new JButton();
			bnRemoveDest.setText("Remove");
		}
		return bnRemoveDest;
	}

	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.editpanel.IEditPanelGUI#setAddDestAction(javax.swing.Action)
	 */
	public void setAddDestAction(Action a) {
		getBnAddDest().setAction(a);		
	}


	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.editpanel.IEditPanelGUI#setRemoveDestAction(javax.swing.Action)
	 */
	public void setRemoveDestAction(Action a) {
		getBnRemoveDest().setAction(a);
	}

	@Override
	protected JTable getTableDestination() {
		JTable table = super.getTableDestination();
		table.setDefaultEditor(Integer.class, getTermEditor() );
		table.setDefaultEditor(TrmCategory.class, trmCategoryEditor);
		
		return table;
	}
	
	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.editpanel.IEditPanelGUI#setAvailableDatabases(java.util.Vector)
	 */
	public void setAvailableDatabases(Vector<ExternDB> dbs) {
	
		JComboBox cbo = new JComboBox(dbs);
		DefaultCellEditor editor = new DefaultCellEditor(cbo);
		cbo.setRenderer(externDBListCellRenderer);
		
//		TableColumn editCol = getTableDestination().getColumnModel().getColumn(3);
//		editCol.setCellEditor(editor);	
		getTableDestination().setDefaultEditor(ExternDB.class, editor);
	}


	public void setRootCategory(TrmCategoryTree rootCategory) {
		trmCategoryEditor.setRootCategory(rootCategory);	
		getTermEditor().setRootCategory(rootCategory);
	}


	/**
	 * This method initializes bnAddSource	
	 * 	
	 * @return javax.swing.JButton	
	 */
	protected JButton getBnAddSource() {
		if (bnAddSource == null) {
			bnAddSource = new JButton();
			bnAddSource.setText("add");
		}
		return bnAddSource;
	}


	/**
	 * This method initializes bnRemoveSource	
	 * 	
	 * @return javax.swing.JButton	
	 */
	protected JButton getBnRemoveSource() {
		if (bnRemoveSource == null) {
			bnRemoveSource = new JButton();
			bnRemoveSource.setText("Remove");
		}
		return bnRemoveSource;
	}


	public void setAddSourceAction(Action a) {
		getBnAddSource().setAction(a);		
	}


	public void setRemoveSourceAction(Action a) {
		getBnRemoveSource().setAction(a);		
	}

	
	protected SelectTermTableCellEditor getTermEditor() {
		if (termEditor == null){
			termEditor = new SelectTermTableCellEditor();
		}
		return termEditor;
	}


	public void valueChanged(ListSelectionEvent e) {
		getTableDestination().removeEditor();		
	}





	/**
	 * This method initializes cboReplaceType	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getCboReplaceType() {
		if (cboReplaceType == null) {
			cboReplaceType = new JComboBox(getCboModelTrlType());
		}
		return cboReplaceType;
	}

	
	public void setAvailableTrlTypes(Vector<TrlType> types) {
		
		/*
		 * SourceTable
		 */
		JComboBox cbo = new JComboBox(types);
		DefaultCellEditor editor = new DefaultCellEditor(cbo);
		cbo.setRenderer(trlTypeistCellRenderer);

		getTableSource().setDefaultEditor(TrlType.class, editor);
		
		/*
		 * ComboBox
		 */
		getCboModelTrlType().removeAllElements();
		getCboReplaceType().setRenderer(trlTypeistCellRenderer);
		for (TrlType type : types) {
			getCboModelTrlType().addElement(type);
		}	
		
	}	


	protected DefaultComboBoxModel getCboModelTrlType() {
		return cboModelTrlType;
	}


	public void setTrlTypeSelectedAction(Action a) {
		getCboReplaceType().setAction(a);		
	}



//	/**
//	 * Renderer for TableCell to show ExternDB 
//	 *
//	 */
//	static class ExternDBRenderer extends DefaultTableCellRenderer {
//	    public void setValue(Object value) {	    	
//	        setText((value == null) ? "" : ((ExternDB)value).getEdbName());
//	    }
//	}
//	
//	/**
//	 * Renderer for TableCell to show ExternDB 
//	 *
//	 */
//	static class TrmCategoryRenderer extends DefaultTableCellRenderer {
//	    public void setValue(Object value) {	    	
//	        setText((value == null) ? "" : ((TrmCategory)value).getTctName());
//	    }
//	}		

}  //  @jve:decl-index=0:visual-constraint="10,10"
