package de.ipk.pdwExpress.curator.view.overview;

import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.border.TitledBorder;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.TableModel;

import de.ipk.pdwExpress.curator.view.viewPanel.ViewPanelGUIImpl;

public class ReplaceOverviewGUIImpl extends JPanel implements IReplaceOverviewGUI {

	private static final long serialVersionUID = 1L;
	private JScrollPane scrollOverviewTable = null;
	private JTable tableOverview = null;
	private JButton bnDelete = null;
	private ViewPanelGUIImpl editPanelGUIImpl = null;
	private ListSelectionListener listSelectionListener;
	private JButton bnLoadRpl = null;
	private JButton bnExecute = null;
	/**
	 * This is the default constructor
	 */
	public ReplaceOverviewGUIImpl() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
		gridBagConstraints21.gridx = 3;
		gridBagConstraints21.insets = new Insets(6, 6, 6, 6);
		gridBagConstraints21.anchor = GridBagConstraints.NORTHEAST;
		gridBagConstraints21.gridy = 1;
		GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
		gridBagConstraints11.gridx = 1;
		gridBagConstraints11.gridwidth = 2;
		gridBagConstraints11.anchor = GridBagConstraints.NORTHWEST;
		gridBagConstraints11.insets = new Insets(6, 6, 6, 6);
		gridBagConstraints11.gridy = 1;
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.gridx = 0;
		gridBagConstraints3.gridwidth = 5;
		gridBagConstraints3.fill = GridBagConstraints.BOTH;
		gridBagConstraints3.weighty = 75.0D;
		gridBagConstraints3.weightx = 100.0D;
		gridBagConstraints3.gridy = 2;
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.insets = new Insets(6, 6, 6, 6);
		gridBagConstraints2.anchor = GridBagConstraints.NORTHEAST;
		gridBagConstraints2.gridy = 1;
		gridBagConstraints2.weightx = 100.0D;
		gridBagConstraints2.weighty = 0.0D;		
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.fill = GridBagConstraints.BOTH;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.weighty = 25;
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridwidth=4;
		this.setBorder(BorderFactory.createEmptyBorder(6,6,6,6));
		this.setSize(300, 200);
		this.setLayout(new GridBagLayout());
		
		this.add(getScrollOverviewTable(), gridBagConstraints);
		this.add(getViewPanelGUI(), gridBagConstraints3);
		this.add(getBnDelete(), gridBagConstraints2);
		
		this.add(getBnLoadRpl(), gridBagConstraints11);
		this.add(getBnExecute(), gridBagConstraints21);
		
		
	}

	/**
	 * This method initializes scrollOvervireTable	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getScrollOverviewTable() {
		if (scrollOverviewTable == null) {
			scrollOverviewTable = new JScrollPane();
			scrollOverviewTable.setViewportView(getTableOverview());
		}
		return scrollOverviewTable;
	}

	/**
	 * This method initializes overview	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getTableOverview() {
		if (tableOverview == null) {
			tableOverview = new JTable();
			tableOverview.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return tableOverview;
	}
	
	/* (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.replacements.IReplaceOverviewGUI#setTableModel(javax.swing.table.TableModel)
	 */
	public void setTableModel (TableModel model){
		getTableOverview().setModel(model);
		setListSelectionListener(listSelectionListener);
	}

	/**
	 * This method initializes bnDelete	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBnDelete() {
		if (bnDelete == null) {
			bnDelete = new JButton();
			bnDelete.setText("Delete");
		}
		return bnDelete;
	}

	public void setDeleteAction(Action a) {
		getBnDelete().setAction(a);		
	}


	public void setLoadRplAction(Action a) {
		getBnLoadRpl().setAction(a);		
	}

	public void setListSelectionListener(ListSelectionListener listSelectionListener){
		this.listSelectionListener=listSelectionListener;
		getTableOverview().getSelectionModel().addListSelectionListener(listSelectionListener);		
	}

	public int getSelectedRow() {
		return getTableOverview().getSelectedRow();
	}

	/**
	 * This method initializes editPanelGUIImpl	
	 * 	
	 * @return de.ipk.pdwExpress.curator.view.editpanel.EditPanelGUIImpl	
	 */
	public ViewPanelGUIImpl getViewPanelGUI() {
		if (editPanelGUIImpl == null) {
			editPanelGUIImpl = new ViewPanelGUIImpl();
			editPanelGUIImpl.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(6, 6, 6, 6), BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(null, "Mapping", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Dialog", Font.BOLD, 12), new Color(51, 51, 51)), BorderFactory.createEmptyBorder(6, 6, 6, 6))));
		}
		return editPanelGUIImpl;
	}

	/**
	 * This method initializes bnLoadRpl	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBnLoadRpl() {
		if (bnLoadRpl == null) {
			bnLoadRpl = new JButton();
			bnLoadRpl.setText("Edit");
		}
		return bnLoadRpl;
	}



	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBnExecute() {
		if (bnExecute == null) {
			bnExecute = new JButton();
			bnExecute.setText("Execute");
		}
		return bnExecute;
	}

	public void setExecuteAction(Action a) {
		getBnExecute().setAction(a);		
	}
	
}
