package de.ipk.pdwExpress.curator.view.panels;

import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.io.InputStream;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;

import org.apache.commons.configuration.PropertiesConfiguration;
import org.apache.log4j.Logger;

public class AboutPanel extends JPanel {

	protected final Logger logger;
	private static final long serialVersionUID = 1L;
	private JLabel lblTitle = null;
	private JLabel lblVersion = null;
	private String appVersion="Version";
	private String appName="Name";
	private String appDesc="Desc";
	private String appInceptionYear="year";  //  @jve:decl-index=0:
//	private String appUrl="url";
	private String appOrganization="organization";
	private JLabel lblYearOrg =null;
	private JTextArea txtDesc =null ;
	/**
	 * This is the default constructor
	 */
	public AboutPanel() {
		super();
		logger = Logger.getLogger(this.getClass());
		
		try {

			PropertiesConfiguration config = new PropertiesConfiguration();
			
			InputStream in = getClass().getResourceAsStream("/application.properties");
			
			if (in == null)
				logger.warn("application.properties inputstream is null");
			
			config.load(in , null);
			
			this.appVersion = config.getString("application.version");
			this.appName = config.getString("application.name");
			this.appDesc = config.getString("application.description");
//			this.appUrl = config.getString("application.url");
			this.appInceptionYear = config.getString("application.inceptionYear");
			this.appOrganization = config.getString("application.organization");
			
			logger.info("appOrganization"+appOrganization);
		} catch (Exception e) { //ConfigurationException 
			logger.fatal("Error while reading properties file.");
			e.printStackTrace();
		}
		
		initialize();
		
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
		gridBagConstraints5.fill = GridBagConstraints.BOTH;
		gridBagConstraints5.gridy = 3;
		gridBagConstraints5.weightx = 1.0;
		gridBagConstraints5.weighty = 1.0;
		gridBagConstraints5.insets = new Insets(6, 0, 0, 0);
		gridBagConstraints5.gridx = 0;
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.anchor = GridBagConstraints.EAST;
		gridBagConstraints2.insets = new Insets(6, 0, 0, 0);
		gridBagConstraints2.gridy = 4;
		lblYearOrg = new JLabel();
		lblYearOrg.setText(appOrganization+" "+appInceptionYear);
		lblYearOrg.setFont(new Font("Dialog", Font.BOLD, 10));
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints1.gridy = 1;
		lblVersion = new JLabel();
		lblVersion.setText("Version "+appVersion);
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		lblTitle = new JLabel();
		lblTitle.setText(appName);
		lblTitle.setFont(new Font("Arial", Font.BOLD | Font.ITALIC, 24));
		this.setSize(357, 214);
		this.setLayout(new GridBagLayout());
		this.add(lblTitle, gridBagConstraints);
		this.add(lblVersion, gridBagConstraints1);
		this.add(lblYearOrg, gridBagConstraints2);
		this.add(getTxtDesc(), gridBagConstraints5);
	}

	/**
	 * This method initializes txtDesc	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getTxtDesc() {
		if (txtDesc == null) {
			txtDesc = new JTextArea(appDesc);
			txtDesc.setWrapStyleWord(true);
			txtDesc.setLineWrap(true);
			txtDesc.setEditable(false);
			txtDesc.setRows(4);
			txtDesc.setFont(new Font("Courier New", Font.PLAIN, 12));
			txtDesc.setBackground(new JLabel().getBackground());
		}
		return txtDesc;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
