package de.ipk.pdwExpress.curator.view.panels;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.Date;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import de.ipk.pdwExpress.persistence.model.Replacement;

public class ReplacementForm extends JPanel {

	private Replacement replacement;
	
	private static final long serialVersionUID = 1L;
	private JLabel lblID = null;
	private JLabel lblAuthor = null;
	private JLabel lblDescription = null;
	private JLabel lblCreationDate = null;
	private JTextField txtID = null;
	private JTextField txtDate = null;
	private JTextField txtAuthor = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JTextArea txtDesc = null;

	private JScrollPane scrollDesc;
	/**
	 * This is the default constructor
	 */
	public ReplacementForm() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
		gridBagConstraints7.fill = GridBagConstraints.BOTH;
		gridBagConstraints7.gridy = 3;
		gridBagConstraints7.weightx = 1.0;
		gridBagConstraints7.weighty = 2.0;
		gridBagConstraints7.gridwidth = 3;
		gridBagConstraints7.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints7.gridx = 1;
		GridBagConstraints gridBagConstraints61 = new GridBagConstraints();
		gridBagConstraints61.gridx = 3;
		gridBagConstraints61.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints61.weightx = 50.0D;
		gridBagConstraints61.gridy = 0;
		jLabel2 = new JLabel();
		jLabel2.setText("       ");
		GridBagConstraints gridBagConstraints51 = new GridBagConstraints();
		gridBagConstraints51.gridx = 2;
		gridBagConstraints51.weightx = 40.0D;
		gridBagConstraints51.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints51.gridy = 0;
		jLabel1 = new JLabel();
		jLabel1.setText("          ");
		GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
		gridBagConstraints6.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints6.gridy = 2;
		gridBagConstraints6.weightx = 100.0D;
		gridBagConstraints6.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints6.gridwidth = 3;
		gridBagConstraints6.gridx = 1;
		GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
		gridBagConstraints5.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints5.gridy = 1;
		gridBagConstraints5.weightx = 10.0D;
		gridBagConstraints5.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints5.gridwidth = 2;
		gridBagConstraints5.gridx = 1;
		GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
		gridBagConstraints4.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints4.gridy = 0;
		gridBagConstraints4.weightx = 30.0D;
		gridBagConstraints4.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints4.anchor = GridBagConstraints.NORTHWEST;
		gridBagConstraints4.gridwidth = 1;
		gridBagConstraints4.gridx = 1;
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.gridx = 0;
		gridBagConstraints3.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints3.anchor = GridBagConstraints.NORTHEAST;
		gridBagConstraints3.gridy = 1;
		lblCreationDate = new JLabel();
		lblCreationDate.setText("CreationDate");
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.anchor = GridBagConstraints.NORTHEAST;
		gridBagConstraints2.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints2.gridy = 3;
		lblDescription = new JLabel();
		lblDescription.setText("Description");
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints1.anchor = GridBagConstraints.NORTHEAST;
		gridBagConstraints1.gridy = 2;
		lblAuthor = new JLabel();
		lblAuthor.setText("Author");
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints.anchor = GridBagConstraints.NORTHEAST;
		gridBagConstraints.gridy = 0;
		lblID = new JLabel();
		lblID.setText("ID");
		this.setSize(300, 200);
		this.setLayout(new GridBagLayout());
		this.add(lblID, gridBagConstraints);
		this.add(lblAuthor, gridBagConstraints1);
		this.add(lblDescription, gridBagConstraints2);
		this.add(lblCreationDate, gridBagConstraints3);
		this.add(getTxtID(), gridBagConstraints4);
		this.add(getTxtDate(), gridBagConstraints5);
		this.add(getTxtAuthor(), gridBagConstraints6);
		this.add(jLabel1, gridBagConstraints51);
		this.add(jLabel2, gridBagConstraints61);
		this.add(getScrollDesc(), gridBagConstraints7);
	}
	
	private JScrollPane getScrollDesc(){
		if (scrollDesc ==null){
			scrollDesc = new JScrollPane(getTxtDesc());			
		}
		return scrollDesc;
	}

	/**
	 * This method initializes txtID	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTxtID() {
		if (txtID == null) {
			txtID = new JTextField();
			txtID.setEditable(false);
		}
		return txtID;
	}

	/**
	 * This method initializes txtDate	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTxtDate() {
		if (txtDate == null) {
			txtDate = new JTextField();
			txtDate.setEditable(false);
		}
		return txtDate;
	}

	/**
	 * This method initializes txtAuthor	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getTxtAuthor() {
		if (txtAuthor == null) {
			txtAuthor = new JTextField();
		}
		return txtAuthor;
	}

	/**
	 * This method initializes txtDesc	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getTxtDesc() {
		if (txtDesc == null) {
			txtDesc = new JTextArea();
		}
		return txtDesc;
	}
	
	public void setReplacement(Replacement r){
		this.replacement=r;
		Integer id = r.getRplId();
		getTxtID().setText(id==null ? "": id.toString());
		Date date = r.getRplCreationdate();
		getTxtDate().setText(date == null? "":date.toString());
		getTxtAuthor().setText(r.getRplAuthor());
		getTxtDesc().setText(r.getRplDesc());
	}
	
	/**
	 * writes inserted data to <code>Replacement</code> Object set by 
	 * <code>setReplacement(Replacement r)</code>
	 * @return
	 */
	public Replacement acceptReplacement(){
		replacement.setRplAuthor(getTxtAuthor().getText());
		replacement.setRplDesc(getTxtDesc().getText());
		return this.replacement;
	}



}
