package de.ipk.pdwExpress.curator.view.panels;

import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

import de.ipk.pdwExpress.persistence.model.Replacement;

public class ReplacementFormDialog extends JDialog implements ActionListener{

	public static final int OK=1;
	public static final int CANCEL =0;
	
	private int pressedButton= CANCEL;
	
	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JButton bnCancel = null;

	private JButton bnOK = null;

	private ReplacementForm replecementPanel = null;
	
	
	public ReplacementFormDialog(){
		this(null);
	}
	/**
	 * @param owner
	 */
	public ReplacementFormDialog(Frame owner) {
		super(owner,true);
		initialize();		
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(350, 250);
		this.setTitle("Replacement");
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 1;
			gridBagConstraints3.anchor = GridBagConstraints.NORTHWEST;
			gridBagConstraints3.fill = GridBagConstraints.BOTH;
			gridBagConstraints3.gridwidth = 3;
			gridBagConstraints3.weightx = 100.0D;
			gridBagConstraints3.weighty = 100.0D;
			gridBagConstraints3.gridy = 0;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 2;
			gridBagConstraints1.insets = new Insets(6, 6, 0, 0);
			gridBagConstraints1.anchor = GridBagConstraints.SOUTHEAST;
			gridBagConstraints1.weightx = 100.0D;
			gridBagConstraints1.gridy = 1;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 3;
			gridBagConstraints.insets = new Insets(6, 6, 0, 0);
			gridBagConstraints.anchor = GridBagConstraints.SOUTHEAST;
			gridBagConstraints.gridy = 1;
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.setBorder(BorderFactory.createEmptyBorder(6, 6, 6, 6));
			jContentPane.add(getBnCancel(), gridBagConstraints);
			jContentPane.add(getBnOK(), gridBagConstraints1);
			jContentPane.add(getReplecementPanel(), gridBagConstraints3);
		}
		return jContentPane;
	}

	/**
	 * This method initializes bnCancel	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBnCancel() {
		if (bnCancel == null) {
			bnCancel = new JButton();
			bnCancel.setText("Cancel");
			bnCancel.addActionListener(this);
		}
		return bnCancel;
	}

	/**
	 * This method initializes bnOK	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBnOK() {
		if (bnOK == null) {
			bnOK = new JButton();
			bnOK.setText("Ok");
			bnOK.addActionListener(this);
		}
		return bnOK;
	}

	/**
	 * This method initializes replecementPanel	
	 * 	
	 * @return de.ipk.pdwExpress.curator.view.panels.ReplecementPanel	
	 */
	private ReplacementForm getReplecementPanel() {
		if (replecementPanel == null) {
			replecementPanel = new ReplacementForm();
		}
		return replecementPanel;
	}
	
	public void actionPerformed(ActionEvent e) {
		
		if (e.getSource()==getBnOK())
			pressedButton=OK;
		else if (e.getSource()== getBnCancel())
			pressedButton= CANCEL;
		
		this.dispose();
	}
	
	public int getPressedButton() {
		return pressedButton;
	}
	

	/**
	 * 
	 * @return A <b>NEW<b> Replacement, contains the edited data.
	 */
	public Replacement getReplacement() {
		return getReplecementPanel().acceptReplacement();
	}

	/**
	 * 
	 * @param replacement A Replacement that will be shown in the dialog.
	 */
	public void setReplacement(Replacement replacement) {
		getReplecementPanel().setReplacement(replacement);
	}	

}  //  @jve:decl-index=0:visual-constraint="10,10"
