package de.ipk.pdwExpress.curator.view.selecttree;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionListener;
import java.util.List;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTree;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeCellRenderer;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

import org.apache.log4j.Logger;

import de.ipk.pdwExpress.curator.view.renderer.TrmCategoryTreeCellRenderer;
import de.ipk.pdwExpress.curator.view.selecttree.nodeRenderer.INodeDetailsRenderer;

/**
 * Panel with Tree and Table.
 * @author Thomas Rutkowski
 *
 */
public class CategoryTreePanelImpl extends JPanel implements TreeSelectionListener, ListSelectionListener,ITreePanel { 
	
	

	protected Logger logger;

	private static final long serialVersionUID = 1L;
	private JLabel lblHeader = null;
	private JButton bnOk = null;
	private JButton bnCancel = null;
	private JScrollPane scrollTree = null;
	private JTree tree = null;
	private JTable tableDetails = null;
	private JLabel lblDetails = null;
//	private JButton bnSearch = null;
	private ActionListener actionListener;
	
	private JPanel detailPanel = null;
	private JLabel lblDummy = null;
	private DefaultTreeModel treeModel;  //  @jve:decl-index=0:
	private INodeDetailsRenderer nodeDetailsRenderer;
	private DefaultTableModel detailsTableModel;


	private boolean selectDetails=false;

	private JSplitPane splitPane = null;

	private TreeCellRenderer treeCellRenderer;

	/**
	 * This is the default constructor
	 */
	private CategoryTreePanelImpl() {
		this(null);
		
	}
	
	/**
	 * 
	 * @param actionListener Listener fpr 'OK' and 'CANCEL' Button
	 */
	public CategoryTreePanelImpl(ActionListener actionListener) {
		super();
		logger = Logger.getLogger(this.getClass());
		this.actionListener=actionListener;
		initialize();
		setDetailSelectAble(false);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(660, 436);
		GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
		gridBagConstraints12.fill = GridBagConstraints.BOTH;
		gridBagConstraints12.gridy = 3;
		gridBagConstraints12.weightx = 1.0;
		gridBagConstraints12.weighty = 1.0;
		gridBagConstraints12.gridwidth = 7;
		gridBagConstraints12.gridx = 0;
		GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
		gridBagConstraints31.fill = GridBagConstraints.BOTH;
		gridBagConstraints31.gridx = 5;
		gridBagConstraints31.gridwidth = 2;
		gridBagConstraints31.gridheight=2;
		gridBagConstraints31.insets = new Insets(0, 12, 0, 0);
		gridBagConstraints31.weightx = 50.0D;
		gridBagConstraints31.weighty = 100.0D;
		gridBagConstraints31.anchor = GridBagConstraints.NORTH;
		gridBagConstraints31.gridy = 2;
		
		GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
		gridBagConstraints21.gridx = 2;
		gridBagConstraints21.gridy = 3;
		GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
		gridBagConstraints11.gridx = 3;
		gridBagConstraints11.anchor = GridBagConstraints.SOUTHEAST;
		gridBagConstraints11.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints11.gridy = 2;

		lblDetails = new JLabel();
		lblDetails.setText("Details of selected node");

		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.gridx = 6;
		gridBagConstraints3.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints3.anchor = GridBagConstraints.SOUTHEAST;
		gridBagConstraints3.gridy = 5;
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 5;
		gridBagConstraints2.insets = new Insets(6, 6, 0, 0);
		gridBagConstraints2.anchor = GridBagConstraints.SOUTHEAST;
		gridBagConstraints2.weightx = 10.0D;
		gridBagConstraints2.gridy = 5;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.fill = GridBagConstraints.NONE;
		gridBagConstraints.insets = new Insets(6, 0, 6, 6);
		gridBagConstraints.gridy = 0;
		lblHeader = new JLabel();
		lblHeader.setText("Select Entry");
		this.setLayout(new GridBagLayout());
		this.setBorder(BorderFactory.createEmptyBorder(6, 6, 6, 6));
		this.add(lblHeader, gridBagConstraints);
		this.add(getBnOk(), gridBagConstraints2);
		this.add(getBnCancel(), gridBagConstraints3);
		this.add(getSplitPane(), gridBagConstraints12);
	}

	/**
	 * This method initializes bnOk	
	 * 	
	 * @return javax.swing.JButton	
	 */
	protected JButton getBnOk() {
		if (bnOk == null) {
			bnOk = new JButton();
			bnOk.setText("OK");
			bnOk.addActionListener(actionListener);
			bnOk.setActionCommand(OK);
			if (isDetailSelectAble())
				bnOk.setEnabled(false);
		}
		return bnOk;
	}

	/**
	 * This method initializes bnCancel
	 * 	
	 * @return javax.swing.JButton	
	 */
	protected JButton getBnCancel() {
		if (bnCancel == null) {
			bnCancel = new JButton();
			bnCancel.setText("Cancel");
			bnCancel.addActionListener(actionListener);
			bnCancel.setActionCommand(CANCEL);
		}
		return bnCancel;
	}

	/**
	 * This method initializes scrollTree	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getScrollTree() {
		if (scrollTree == null) {
			scrollTree = new JScrollPane();
			scrollTree.setViewportView(getTree());
		}
		return scrollTree;
	}

	/**
	 * This method initializes tree	
	 * 	
	 * @return javax.swing.JTree	
	 */
	protected JTree getTree() {
		if (tree == null) {
			tree = new JTree( getTreeModel());
			tree.setExpandsSelectedPaths(true);			
	        //nur eine zeile ist auswaehlbar
			tree.getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
			tree.setCellRenderer(getTreeCellRenderer());
			tree.getSelectionModel().addTreeSelectionListener(this);
		}
		return tree;
	}
	
	protected TreeCellRenderer getTreeCellRenderer() {
		if (treeCellRenderer == null){
			treeCellRenderer= new TrmCategoryTreeCellRenderer();
		}
		return treeCellRenderer;
	}

	/* (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.ITreePanel#addTreeSelectionListener(javax.swing.event.TreeSelectionListener)
	 */
	public void addTreeSelectionListener(TreeSelectionListener tsl){
		getTree().getSelectionModel().addTreeSelectionListener(tsl);
	}

	/**
	 * This method initializes tableDetails	
	 * 	
	 * @return javax.swing.JTable	
	 */
	protected JTable getTableDetails() {
		if (tableDetails == null) {
			tableDetails = new JTable(getDetailsTableModel());
			tableDetails.getSelectionModel().addListSelectionListener(this);
			tableDetails.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return tableDetails;
	}

//	/**
//	 * This method initializes bnSearch	
//	 * 	
//	 * @return javax.swing.JButton	
//	 */
//	private JButton getBnSearch() {
//		if (bnSearch == null) {
//			bnSearch = new JButton();
//			bnSearch.setText("search");
//		}
//		return bnSearch;
//	}



	/**
	 * This method initializes searchPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getDetailPanel() {
		if (detailPanel == null) {
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 2;
			gridBagConstraints5.gridy = 4;
			lblDummy = new JLabel();
			lblDummy.setText("");
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 2;
			gridBagConstraints7.insets = new Insets(6, 6, 6, 6);
			gridBagConstraints7.fill = GridBagConstraints.NONE;
			gridBagConstraints7.weighty = 100.0D;
			gridBagConstraints7.weightx = 20.0D;
			gridBagConstraints7.anchor = GridBagConstraints.SOUTHEAST;
			gridBagConstraints7.gridy = 2;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.fill = GridBagConstraints.BOTH;
			gridBagConstraints4.gridwidth = 2;
			gridBagConstraints4.gridx = 1;
			gridBagConstraints4.gridy = 1;
			gridBagConstraints4.weightx = 20.0D;
			gridBagConstraints4.weighty = 80.0D;
			gridBagConstraints4.insets = new Insets(6, 6, 6, 6);
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.insets = new Insets(6, 6, 0, 0);
			gridBagConstraints6.gridy = 0;
			
			detailPanel = new JPanel();
			detailPanel.setBorder(BorderFactory.createEtchedBorder());
			detailPanel.setLayout(new GridBagLayout());
			detailPanel.setPreferredSize(new Dimension(460, 490));
			detailPanel.add(lblDetails, gridBagConstraints6);
			detailPanel.add(new JScrollPane(getTableDetails()), gridBagConstraints4);
			detailPanel.add(lblDummy, gridBagConstraints5);
		}
		return detailPanel;
//		return new JPanel();
	}

	protected DefaultTreeModel getTreeModel(){
		if (treeModel==null){
			treeModel = new DefaultTreeModel(null);
		}
		return treeModel;
	}
	/* (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.ITreePanel#setRoot(javax.swing.tree.TreeNode)
	 */
	public void setRoot(TreeNode root) {
		getTreeModel().setRoot(root);
	}
	
	/* (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.ITreePanel#getSelectedEntries()
	 */
	public List<Object> getSelectedEntries(){
		
		Vector<Object> listSelObjects = new Vector<Object>(getTree().getSelectionCount());
		
		if (getTree().getSelectionPaths() != null)
			for(TreePath tp: getTree().getSelectionPaths()){
				listSelObjects.add(((DefaultMutableTreeNode)tp.getLastPathComponent()).getUserObject() );
			}

		return listSelObjects;
	}
	
	/* (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.ITreePanel#getFirstSelectedEntry()
	 */
	public Object getFirstSelectedEntry(){
		List<Object> all = getSelectedEntries();
		return all.size() == 0?null:all.get(0);
	}

	
	/* (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.ITreePanel#getNodeDetailsRenderer()
	 */
	public INodeDetailsRenderer getNodeDetailsRenderer() {
		return nodeDetailsRenderer;
	}

	/* (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.ITreePanel#setNodeDetailsRenderer(de.ipk.pdwExpress.curator.view.selecttree.NodeDetailsRenderer)
	 */
	public void setNodeDetailsRenderer(INodeDetailsRenderer nodeDetailsRenderer) {
		this.nodeDetailsRenderer = nodeDetailsRenderer;
	}

	/*
	 * (non-Javadoc)
	 * @see javax.swing.event.TreeSelectionListener#valueChanged(javax.swing.event.TreeSelectionEvent)
	 */
	public void valueChanged(TreeSelectionEvent e) {
	
	    Object selected =getFirstSelectedEntry();
		logger.debug("valueChanged. selected:"+selected+ "  nodeDetailsRenderer:"+getNodeDetailsRenderer());

		
		if (getNodeDetailsRenderer() == null || selected ==null)
			return;
		
		Vector dataVector =getNodeDetailsRenderer().getNodeView(selected);
		Vector columnIdentifiers=getNodeDetailsRenderer().getColumnHeaders();
		
		getDetailsTableModel().setDataVector(dataVector, columnIdentifiers);
	}

	
	protected DefaultTableModel getDetailsTableModel() {
		if (detailsTableModel ==null){
			detailsTableModel= new DefaultTableModel(){;
			private static final long serialVersionUID = 1L;

		    	@Override
				public boolean isCellEditable(int row, int column) {
		    		return false;
		    	}
			};
		}
		return detailsTableModel;
	}

	/*
	 * (non-Javadoc)
	 * @see javax.swing.event.ListSelectionListener#valueChanged(javax.swing.event.ListSelectionEvent)
	 */
	public void valueChanged(ListSelectionEvent e) {
		int index = getTableDetails().getSelectedRow();
		if (isDetailSelectAble())
			getBnOk().setEnabled(index != -1);		
	}

	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.ITreePanel#isDetailSelectAble()
	 */
	public boolean isDetailSelectAble() {
		return selectDetails;
	}

	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.ITreePanel#setSelectDetails(boolean)
	 */
	public void setDetailSelectAble(boolean selectDetails) {
		this.selectDetails = selectDetails;
		
		// setEnabled OK button 
		int index = getTableDetails().getSelectedRow();
		if (isDetailSelectAble())
			getBnOk().setEnabled(index != -1);
		else
			getBnOk().setEnabled(true);
		
		// selection
		getTableDetails().setEnabled(selectDetails);
	}

	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.ITreePanel#getSelectedDetailIndex()
	 */
	public int getSelectedDetailIndex() {
		return getTableDetails().getSelectedRow();
	}

	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.ITreePanel#getSelectedDetail()
	 */
	public Object getSelectedDetail() {
		int i=getSelectedDetailIndex();
		if(i>-1)
			return getNodeDetailsRenderer().getDetailItem(i);
		
		return null;
	}

	/**
	 * This method initializes splitPane	
	 * 	
	 * @return javax.swing.JSplitPane	
	 */
	private JSplitPane getSplitPane() {
		if (splitPane == null) {
			splitPane = new JSplitPane();
			splitPane.setLeftComponent(getScrollTree());
			splitPane.setRightComponent(getDetailPanel());
			splitPane.setOneTouchExpandable(true);
			splitPane.setDividerLocation(250);
			splitPane.setResizeWeight(0.5);
			
		}
		return splitPane;
	}




	
	//TODO setSelectedEntries
//	public void setSelectedEntries( List<Object> sel){
//		
//		
//		getTree().setSelectionPath(null);
//	}

}
