package de.ipk.pdwExpress.curator.view.selecttree;

import java.util.List;

import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.TreeNode;

import de.ipk.pdwExpress.curator.view.selecttree.nodeRenderer.INodeDetailsRenderer;

public interface ITreePanel <T> {
	
	public static final String OK="Ok";  
	public static final String CANCEL ="Cancel";  	

	public void addTreeSelectionListener(TreeSelectionListener tsl);

	public void setRoot(TreeNode root);

	/**
	 * @see DefaultMutableTreeNode.getUserObject()
	 * @return List with 'UserObjects' of all selected Nodes. Never Null.
	 */
	public List<Object> getSelectedEntries();

	/**
	 * @see getSelectedEntries() 
	 * @return The first Result of 'getSelectedEntries()'. Null, if List is empty.
	 */
	public Object getFirstSelectedEntry();

	public INodeDetailsRenderer getNodeDetailsRenderer();

	public void setNodeDetailsRenderer(INodeDetailsRenderer nodeDetailsRenderer);
	
	/**
	 * 
	 * @param selectDetails TRUE indicates that details are selectable
	 */
	public void setDetailSelectAble(boolean selectDetails);
	
	/**
	 * 
	 * @return TRUE if a detail of curent node is selected
	 */
	public boolean isDetailSelectAble();
	
	public int getSelectedDetailIndex();

	/**
	 * 
	 * @return The select Object
	 */
	public Object getSelectedDetail();

}