package de.ipk.pdwExpress.curator.view.selecttree.nodeRenderer;

import java.util.List;
import java.util.Vector;

import de.ipk.pdwExpress.curator.CuratorApp;
import de.ipk.pdwExpress.persistence.dataAccess.TermDAO;
import de.ipk.pdwExpress.persistence.model.ExternDB;
import de.ipk.pdwExpress.persistence.model.Term;
import de.ipk.pdwExpress.persistence.model.TrmCategory;

public class CategoryTermNodeDetailsRenderer implements INodeDetailsRenderer<TrmCategory,Term> {

	private static Vector<String> columnIdentifiers = new Vector<String>(4);
	private final TermDAO termDao = new TermDAO();
	private List<Term> terms;
	static{
		columnIdentifiers.add("ID");
		columnIdentifiers.add("Value");
		columnIdentifiers.add("Accession");
		columnIdentifiers.add("Database");
	}
	
	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.nodeRenderer.INodeDetailsRenderer#getColumnHeaders()
	 */
	public Vector<String> getColumnHeaders() {
		return columnIdentifiers;
	}

	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.nodeRenderer.INodeDetailsRenderer#getNodeView(java.lang.Object)
	 */
	public Vector<Vector<Object>> getNodeView(TrmCategory node) {
		
		Vector<Vector<Object>> all = new Vector<Vector<Object>>();
		
		terms =termDao.getByCategoryName(node.getTctName(),CuratorApp.getConnection());
		
		for (Term term : terms){
			Vector row = new Vector(4);
			row.add(term.getTrmId());
			row.add(term.getTrmValue());
			row.add(term.getTrmEdbacc());
			ExternDB edb = term.getExterndb();
			row.add( (edb == null) ? "" : edb.getEdbName());
			
			all.add(row);
		}

		return all;
	}
	
	/*
	 * (non-Javadoc)
	 * @see de.ipk.pdwExpress.curator.view.selecttree.nodeRenderer.INodeDetailsRenderer#getDetailItem(int)
	 */
	public Term getDetailItem(int i){
		return terms.get(i);
	}

}
