package de.ipk.pdwExpress.curator.view.statusbar;

import java.awt.ComponentOrientation;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.border.EtchedBorder;

public class StatusBarImpl extends JPanel implements IStatusBar{

	private final static String NO_MESSAGE="";  //  @jve:decl-index=0:
	private static final long serialVersionUID = 1L;
	private JLabel lblStatus = null;
	private JProgressBar progressBar = null;
	/**
	 * This is the default constructor
	 */
	public StatusBarImpl() {
		super();
		initialize();
		clear();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.insets = new Insets(0, 12, 0, 0);
		gridBagConstraints1.anchor = GridBagConstraints.EAST;
		gridBagConstraints1.weightx = 10.0D;
		gridBagConstraints1.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.gridy = 0;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.anchor = GridBagConstraints.WEST;
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.gridwidth = 1;
		gridBagConstraints.weightx = 90.0D;
		gridBagConstraints.gridy = 0;
		this.setSize(510, 100);
		this.setLayout(new GridBagLayout());
		this.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(6, 0,0,0), BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED), BorderFactory.createEmptyBorder(3,3,3,3))));
		this.add(getStatusLabel(), gridBagConstraints);
		this.add(getProgressBar(), gridBagConstraints1);
	}
	
	private JLabel getStatusLabel(){
		if (lblStatus==null){
			lblStatus = new JLabel();
			lblStatus.setText("xxx");
			lblStatus.setFont(new Font("Dialog", Font.BOLD, 10));
			lblStatus.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		}
		return lblStatus;
	}

	/**
	 * This method initializes progressBar	
	 * 	
	 * @return javax.swing.JProgressBar	
	 */
	private JProgressBar getProgressBar() {
		if (progressBar == null) {
			progressBar = new JProgressBar(0,100);
		}
		return progressBar;
	}

	public void clear() {
		getStatusLabel().setText(NO_MESSAGE);	
		getProgressBar().setValue(0);
	}

	public void setProgress(int i) {
		getProgressBar().setValue(i);
		
	}

	public void setProgress(int i, int max) {
		getProgressBar().setValue(i);
		getProgressBar().setMaximum(max);
	}

	public void setStatus(String s) {
		getStatusLabel().setText(s);	
	}

	public void setProgressIndeterminate(boolean s) {
		getProgressBar().setIndeterminate(s);		
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
