package de.ipk.pdwExpress.curator.view.titlepanel;

import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.EtchedBorder;

public class TitlePanelImpl extends JPanel implements ITitlePanel{

	private static final long serialVersionUID = 1L;
	private JLabel lblTitle = null;
	private JLabel lblDescription = null;
	private JLabel lblIcon = null;

	/**
	 * This is the default constructor
	 */
	public TitlePanelImpl() {
		super();
		initialize();
		setBackground(Color.LIGHT_GRAY);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.insets = new Insets(6, 6, 6, 6);
		gridBagConstraints2.anchor = GridBagConstraints.NORTHWEST;
		gridBagConstraints2.gridheight = 2;
		gridBagConstraints2.fill = GridBagConstraints.BOTH;
		gridBagConstraints2.gridy = 0;

		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints1.anchor = GridBagConstraints.NORTHWEST;
		gridBagConstraints1.weightx = 100.0D;
		gridBagConstraints1.gridy = 1;
		gridBagConstraints1.insets = new Insets(0,12,6,0);
	
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.insets = new Insets(6, 0, 0, 6);
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = GridBagConstraints.NORTHWEST;
		gridBagConstraints.weightx = 100.0D;
		gridBagConstraints.gridy = 0;
		
		this.setSize(649, 68);
		this.setLayout(new GridBagLayout());
		this.setBackground(Color.white);
		this.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(6, 6, 6, 6), BorderFactory.createEtchedBorder(EtchedBorder.RAISED)));
		this.add(getLblTitle(), gridBagConstraints);
		this.add(getLblDescription() , gridBagConstraints1);
		this.add(getLblIcon(), gridBagConstraints2);
	}


	private JLabel getLblDescription() {
		
		if (lblDescription ==null){
			lblDescription = new JLabel();
//			lblDescription.setText("Description");
			lblDescription.setFont(new Font("Dialog", Font.PLAIN, 10));
			lblDescription.setForeground(Color.DARK_GRAY);
		}
		
		return lblDescription;
	}

	private JLabel getLblIcon() {
		if (lblIcon ==null){
			lblIcon = new JLabel();
			lblIcon.setText("");			
		}
		
		return lblIcon;
	}

	private JLabel getLblTitle() {
		if (lblTitle ==null){
			lblTitle = new JLabel();
			lblTitle.setText("Title");
			lblTitle.setForeground(Color.blue);
			lblTitle.setFont(new Font("Dialog", Font.BOLD, 14));			
		}
		
		return lblTitle;
	}

	public void setDescription(String d) {
		getLblDescription().setText(d);		
	}

	public void setIcon(Icon i) {
		getLblIcon().setIcon(i);		
	}

	public void setTitle(String t) {
		getLblTitle().setText(t);		
	}

	public void setAction(Action a) {
		
		if(a==null){
			clear();
			return;
		}
		
		setTitle((String) a.getValue(Action.NAME));
		
		setDescription((String) a.getValue(Action.SHORT_DESCRIPTION));
		getLblDescription().setToolTipText((String) a.getValue(Action.LONG_DESCRIPTION));
		
		Icon i=(Icon) a.getValue("LARGE_ICON");
		if (i ==null)
			i = (Icon) a.getValue(Action.SMALL_ICON);
		setIcon(i);
	}

	public void clear() {
		setTitle("");
		setDescription("");
		setIcon(null);
		
	}

	public void setBackgroundColor(Color backgroundColorc) {
		this.setBackground(backgroundColorc);
	}

	public void setDescriptionColor(Color descriptionColor) {
		getLblDescription().setForeground(descriptionColor);
	}

	public void setTitleColor(Color titleColor) {
		getLblTitle().setForeground(titleColor);
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
