package de.ipk.pdwExpress.ols.connection;


/**
 * Contains some queries for the ols
 * 
 * @author Thomas Rutkowski
 *
 */
public interface IOlsQueries {

	/**
	 * Name of the OLS Database user
	 */
	public static final String OLS_DB_USER = "PDW_OLS";
	
	public static final String TREEQUERY=
		"with helper as( "+
		"    SELECT "+
		"        t.TERM_ID "+
		"        , TERM_NAME "+
		"        , IDENTIFIER "+
		"        , DEFINITION "+
		"        , NAMESPACE "+
		"        , IS_OBSOLETE "+
		"        , IS_ROOT_TERM "+
		"        , IS_LEAF  " +
		"		 , t.ONTOLOGY_ID "+
		"        ,subject_term_id "+
		"        ,object_term_id "+
		"    FROM "+
		"        "+OLS_DB_USER+".term t "+
		"    join "+OLS_DB_USER+".TERM_RELATIONSHIP r on term_id = subject_term_id "+
		"    where t.ontology_id = ? "+
		"    and r.ontology_id = ? "+
		") "+
		"SELECT "+
		"   level "+
		"    ,TERM_ID "+
		"    , TERM_NAME "+
		"    , IDENTIFIER "+
		"    , DEFINITION "+
		"    , NAMESPACE "+
		"    , IS_OBSOLETE "+
		"    , IS_ROOT_TERM "+
		"    , IS_LEAF  " +
		"	 , ONTOLOGY_ID "+
		"FROM "+
		"    helper "+
		"START WITH object_term_id = ? "+
		"connect by prior  subject_term_id=object_term_id ";	
	
	
	public static final String NODE=	
					"select " +
						"TERM_ID, TERM_NAME, IDENTIFIER, DEFINITION, NAMESPACE, IS_OBSOLETE, IS_ROOT_TERM, IS_LEAF,ONTOLOGY_ID " +
					"from "+OLS_DB_USER+".term where TERM_ID = ? ";	
	


	// TODO nur die neueste version anzeigen
	public static final String ONTOLOGIES = 
		"SELECT "+
		"    ONTOLOGY_ID "+
		"    , SHORTNAME "+
		"    , FULLY_LOADED "+
		"    , LOAD_DATE "+
		"    , FULLNAME "+
		"    , QUERY_URL "+
		"    , SOURCE_URL "+
		"    , VERSION "+
		"    , DEFINITION" +
		"	 , ontology_id  "+
		"FROM "+
		"    "+OLS_DB_USER+".ONTOLOGY  "+
		"WHERE "+
		"    FULLY_LOADED =1 ";		
	
	public static final String ROOTTERM =
	"SELECT "+
	"    t.TERM_ID "+
	"    , TERM_NAME "+
	"    , IDENTIFIER "+
	"    , DEFINITION "+
	"    , NAMESPACE "+
	"    , IS_OBSOLETE "+
	"    , IS_ROOT_TERM "+
	"    , IS_LEAF  "+
	"    , ONTOLOGY_ID "+
	"FROM "+
	"    "+OLS_DB_USER+".term t "+
	"where is_root_term=1 "+
	"and ontology_id = ?  ";
	
	
	public static final String ONTOLOGYBYID = "select * from  "+OLS_DB_USER+".ontology where ontology_id = ?";
}