package de.ipk.pdwExpress.ols.view;

import javax.swing.table.AbstractTableModel;

import de.ipk.pdwExpress.ols.model.OlsTerm;

public class OlsTermTableModel extends AbstractTableModel {
	
	private OlsTerm olsTerm=null;
	private static final String[] FIRSTCOLUMN= new String[]{"termID", "term_name", "identifier", "definition", "nameSpace", "isObsolete", "isRootTerm", "isLeaf"};
	
	

	public int getColumnCount() {
		return 2;
	}

	public int getRowCount() {
		return 8;
	}

	public Object getValueAt(int rowIndex, int columnIndex) {
		
		if (columnIndex==0)
			return FIRSTCOLUMN[rowIndex];
		
		
		if (olsTerm == null)
			return null;
		
		switch(rowIndex){
			case 0: return olsTerm.getTermID();
			case 1: return olsTerm.getTerm_name();
			case 2: return olsTerm.getIdentifier();
			case 3: return olsTerm.getDefinition();
			case 4: return olsTerm.getNameSpace();
			case 5: return olsTerm.isObsolete();
			case 6: return olsTerm.isRootTerm();
			case 7: return olsTerm.isLeaf();
			default: return "error";
		}
		
	}

	public final OlsTerm getOlsTerm() {
		return olsTerm;
	}

	public final void setOlsTerm(OlsTerm olsTerm) {
		this.olsTerm = olsTerm;
		fireTableDataChanged();
	}

}
