package de.ipk.pdwExpress.ols.view;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.SQLException;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

import de.ipk.pdwExpress.ols.connection.IOlsDao;
import de.ipk.pdwExpress.ols.model.OlsOntology;
import de.ipk.pdwExpress.ols.model.OlsTerm;
import de.ipk.pdwExpress.ols.model.OntologyRoot;

public class OlsTreePanel extends JPanel {

	private static final long serialVersionUID = 1L;
	private JComboBox cboOntologies = null;
	private JScrollPane scrollDetails = null;
	private JTable tableDetails = null;
	private JScrollPane scrollTree = null;
	private JTree tree = null;
	private JButton bnOK = null;
	private JButton bnCancel = null;
	private DefaultTreeModel treeModel =null;
	private OlsTermTableModel detailsTableModel=null;
	private JScrollPane scrollDefinition = null;
	private JTextArea txtTermDefinition = null;
	private JLabel lblDummy = null;
	public static final String ACT_CMD_OK="ok";
	public static final String ACT_CMD_CANCEL="cancel";
	private final IOlsDao olsDao;
	private DefaultComboBoxModel comboBoxModel;
	private JTextArea txtOntologyDefinition;

	private OlsTreePanel(){
		super();
		this.olsDao=null;
		initialize();	
	}
	/**
	 * This is the default constructor
	 */
	public OlsTreePanel(IOlsDao oldDao) {
		super();
		this.olsDao=oldDao;
		initData();
		initialize();	
		
		
	}
	
	private void initData(){
		try {
			List<OntologyRoot> ontologies = olsDao.getOntologyRoots();
			
			for (OlsOntology ontology : ontologies) {
				getComboBoxModel().addElement(ontology);
			}
			
		} catch (SQLException e) {
			e.printStackTrace();
			return;
		}
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
		gridBagConstraints22.gridx = 0;
		gridBagConstraints22.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints22.weighty = 0;
		gridBagConstraints22.gridwidth = 3;
		gridBagConstraints22.gridy = 1;
		
		GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
		gridBagConstraints21.gridx = 1;
		gridBagConstraints21.fill = GridBagConstraints.BOTH;
		gridBagConstraints21.weighty = 50.0D;
		gridBagConstraints21.gridwidth = 3;
		gridBagConstraints21.gridy = 4;
		lblDummy = new JLabel();
		lblDummy.setText("   ");
		GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
		gridBagConstraints11.fill = GridBagConstraints.BOTH;
		gridBagConstraints11.gridy = 3;
		gridBagConstraints11.weightx = 50.0D;
		gridBagConstraints11.weighty = 50.0D;
		gridBagConstraints11.gridwidth = 2;
		gridBagConstraints11.anchor = GridBagConstraints.NORTH;
		gridBagConstraints11.insets = new Insets(6, 0, 0, 0);
		gridBagConstraints11.gridx = 1;
		GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
		gridBagConstraints4.gridx = 1;
		gridBagConstraints4.insets = new Insets(12, 0, 0, 6);
		gridBagConstraints4.weightx = 1.0D;
		gridBagConstraints4.anchor = GridBagConstraints.EAST;
		gridBagConstraints4.gridy = 5;
		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
		gridBagConstraints3.gridx = 2;
		gridBagConstraints3.insets = new Insets(12, 0, 0, 0);
		gridBagConstraints3.gridy = 5;
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.fill = GridBagConstraints.BOTH;
		gridBagConstraints2.gridy = 2;
		gridBagConstraints2.weightx = 50;
		gridBagConstraints2.weighty = 100;
		gridBagConstraints2.insets = new Insets(0, 0, 0, 6);
		gridBagConstraints2.gridheight = 3;
		gridBagConstraints2.gridx = 0;
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.fill = GridBagConstraints.BOTH;
		gridBagConstraints1.gridy = 2;
		gridBagConstraints1.weightx = 50;
		gridBagConstraints1.weighty = 0;
		gridBagConstraints1.gridx = 1;
		gridBagConstraints1.gridwidth=2;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.insets = new Insets(0, 0, 12, 6);
		gridBagConstraints.gridx = 0;
		this.setSize(691, 463);
		this.setBorder(BorderFactory.createEmptyBorder(6, 6, 6, 6));
		this.setLayout(new GridBagLayout());
		this.add(getCboOntologies(), gridBagConstraints);
		this.add(getScrollDetails(), gridBagConstraints1);
		this.add(getScrollTree(), gridBagConstraints2);
		this.add(getBnOK(), gridBagConstraints4);
		this.add(getBnCancel(), gridBagConstraints3);
		this.add(getScrollDefinition(), gridBagConstraints11);
		this.add(getTxtOntologyDefinition(),gridBagConstraints22);
		this.add(lblDummy, gridBagConstraints21);
	}

	private JTextArea getTxtOntologyDefinition() {
		if (txtOntologyDefinition == null){
			txtOntologyDefinition= new JTextArea(5,20);
			txtOntologyDefinition.setLineWrap(true);
			txtOntologyDefinition.setWrapStyleWord(true);
			txtOntologyDefinition.setBackground(new JLabel().getBackground());
			txtOntologyDefinition.setEditable(false);
		}
		return txtOntologyDefinition;
	}
	/**
	 * This method initializes cobRoot	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getCboOntologies() {
		if (cboOntologies == null) {
			cboOntologies = new JComboBox(getComboBoxModel());
			cboOntologies.setRenderer(new OntologyRootListCellRenderer());
			cboOntologies.addActionListener(new ActionListener(){

				public void actionPerformed(ActionEvent e) {
					OntologyRoot ontRoot =(OntologyRoot)cboOntologies.getSelectedItem();
					if (ontRoot != null){
						try {
							setRootNode( olsDao.getOntologyRootNode(ontRoot.getRootTerm().getTermID()));
							getTxtOntologyDefinition().setText(ontRoot.getDefinition());

						} catch (SQLException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
				}
				
			});
		}
		return cboOntologies;
	}

	/**
	 * This method initializes scrollDetails	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getScrollDetails() {
		if (scrollDetails == null) {
			scrollDetails = new JScrollPane();
			scrollDetails.setViewportView(getTableDetails());
			scrollDetails.setMinimumSize(new Dimension(250,150));
			scrollDetails.setPreferredSize(new Dimension(250,150));				
		}
		return scrollDetails;
	}

	/**
	 * This method initializes tableDetails	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getTableDetails() {
		if (tableDetails == null) {
			tableDetails = new JTable( getDetailsTableModel());
		}
		return tableDetails;
	}

	/**
	 * This method initializes scrollTree	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getScrollTree() {
		if (scrollTree == null) {
			scrollTree = new JScrollPane();
			scrollTree.setViewportView(getTree());
			scrollTree.setMinimumSize(new Dimension(200,500));
//			scrollTree.setPreferredSize(new Dimension(300,500));
		}
		return scrollTree;
	}

	/**
	 * This method initializes tree	
	 * 	
	 * @return javax.swing.JTree	
	 */
	private JTree getTree() {
		if (tree == null) {
			tree = new JTree(getTreeModel());
			tree.setCellRenderer(new OlsTermTreeCellRenderer());
			tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
			tree.getSelectionModel().addTreeSelectionListener(new TreeSelectionListener(){

				public void valueChanged(TreeSelectionEvent e) {
					
					OlsTerm term =getSelectedTerm();
 
					if (term == null)
						return;
					
					getDetailsTableModel().setOlsTerm(term);
					getTxtTermDefinition().setText(term.getDefinition());
				}
				
			});
		}
		return tree;
	}

	/**
	 * This method initializes bnOK	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBnOK() {
		if (bnOK == null) {
			bnOK = new JButton();
			bnOK.setText("Ok");
			bnOK.setActionCommand(ACT_CMD_OK);
		}
		return bnOK;
	}

	/**
	 * This method initializes bnCancel	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBnCancel() {
		if (bnCancel == null) {
			bnCancel = new JButton();
			bnCancel.setText("Cancel");
			bnCancel.setActionCommand(ACT_CMD_CANCEL);
		}
		return bnCancel;
	}
	
	public void setRootNode(TreeNode root){
		getTreeModel().setRoot(root);
	}

	protected DefaultTreeModel getTreeModel() {
		if (treeModel==null)
			treeModel=new DefaultTreeModel(null);
		return treeModel;
	}

	protected OlsTermTableModel getDetailsTableModel() {
		if (detailsTableModel==null)
			detailsTableModel=new OlsTermTableModel();
		return detailsTableModel;
	}

	/**
	 * This method initializes scrollDefinition	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getScrollDefinition() {
		if (scrollDefinition == null) {
			scrollDefinition = new JScrollPane();
			scrollDefinition.setViewportView(getTxtTermDefinition());
		}
		return scrollDefinition;
	}

	/**
	 * This method initializes txtDefination	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getTxtTermDefinition() {
		if (txtTermDefinition == null) {
			txtTermDefinition = new JTextArea();
			txtTermDefinition.setLineWrap(true);
			txtTermDefinition.setWrapStyleWord(true);
			txtTermDefinition.setEditable(false);			
		}
		return txtTermDefinition;
	}
	
	/**
	 * Add the Listener to ok and cancel button
	 * @param l
	 */
	public void addActionListener(ActionListener l){
		getBnCancel().addActionListener(l);
		getBnOK().addActionListener(l);
	}

	private DefaultComboBoxModel getComboBoxModel() {
		if (comboBoxModel==null)
			comboBoxModel = new DefaultComboBoxModel();
		return comboBoxModel;
	}
	
	public OlsTerm getSelectedTerm() {
		
		if(getTree().isSelectionEmpty())
			return null;
		
		TreePath path = getTree().getSelectionModel().getSelectionPath();
//		if (path == null)
//			return null;
		
		DefaultMutableTreeNode selectedNote =(DefaultMutableTreeNode)path.getLastPathComponent();
		
		OlsTerm term = (OlsTerm) selectedNote.getUserObject();
		
		return term;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
