package de.ipk.pdwExpress.persistence.dataAccess;

import java.sql.Connection;
import java.util.List;

import org.apache.commons.lang.NotImplementedException;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Restrictions;

import de.ipk.pdwExpress.persistence.model.ExternDB;

public class ExternDbDAO extends AbstractDAO<ExternDB> {

	public List<ExternDB> getAll(Connection con) {
		Session s =HibernateUtil.getSession(con);
		Transaction transaction =s.beginTransaction();
		List<ExternDB> edbs=  s.createCriteria(ExternDB.class).list();
		
		transaction.commit();
		s.close();
		return edbs;
	}

	public ExternDB getByID(Integer id,Connection con) {
		throw new NotImplementedException();
	}
	
	public List<ExternDB> getByName(String edbName,Connection con){
		Session s =HibernateUtil.getSession(con);
		Transaction transaction =s.beginTransaction();
		
		List<ExternDB> edbs= s.createCriteria(ExternDB.class).add(Restrictions.like("edbName", edbName)).list();
		transaction.commit();
		s.close();
		return edbs;
		
	}


	public ExternDB getByShortName(String edbName,Connection con) {
		Session s =HibernateUtil.getSession(con);
		Transaction transaction =s.beginTransaction();
				
		ExternDB edb = (ExternDB) s.createCriteria(ExternDB.class).add(Restrictions.like("edbShortName", edbName)).setCacheable(true).uniqueResult();
		logger.info("getByShortName   edbName:"+edbName+" edb:"+edb);
//		ExternDB edb=null;
//		if(edbs != null && !edbs.isEmpty())
//			edb=edbs.get(0);
		
		transaction.commit();
		s.close();
		return edb;
	}
	

	public ExternDB synchronizeByShortName(ExternDB srcEdb,Connection con)  {
		
		ExternDB edb =null;
		
		if (srcEdb != null){
			ExternDbDAO edbDAO = new ExternDbDAO();
			edb = edbDAO.getByShortName(srcEdb.getEdbShortName(),con);
			
//			if (edb == null){
//				logger.info("ExternDB does not exists. Insert externDB. externDB:"+srcEdb);
//				this.save(srcEdb);
//				edb=srcEdb;
//			}
				
		}
		
		return edb;
	}	


}
