package de.ipk.pdwExpress.persistence.dataAccess;

import java.sql.Connection;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Restrictions;

import de.ipk.pdwExpress.persistence.model.Term;

public class TermDAO extends AbstractDAO<Term> {

	public List<Term> getAll(Connection con) {
		Session s =HibernateUtil.getSession(con);
//		Transaction transaction =s.beginTransaction();
		List<Term> terms = s.createCriteria(Term.class).list();
		s.close();
		return  terms;
	}

	public List<Term> getByCategoryName(String tctName,Connection con) {
		Session s =HibernateUtil.getSession(con);
//		Transaction transaction =s.beginTransaction();
		List<Term> terms = s.createCriteria(Term.class).createCriteria("trmCategory").add(Restrictions.eq("tctName", tctName)).list();
		s.close();
		return terms;
	}
	
//	public Term getByID(Integer id,Connection con) {
//		// TODO Auto-generated method stub
//		return null;
//	}


	/**
	 * 
	 * @param tctName
	 * @param trmValue
	 * @return
	 */
	public List<Term> getByCatagoryNameAndValue(String tctName, String trmValue,Connection con) {
		Session s =HibernateUtil.getSession(con);
//		Transaction transaction =s.beginTransaction();
		List<Term> terms = s.createCriteria(Term.class).add(
											Restrictions.eq("trmValue", trmValue)).createCriteria(
											"trmCategory").add(Restrictions.eq("tctName", tctName)).list();
		s.close();
		return terms;
	}
	
	/**
	 * 
	 * @param tctName
	 * @param trmValue
	 * @return
	 */
	public List<Term> getBySQLWhere(String sqlWhere,Connection con) {
		Session s =HibernateUtil.getSession(con);
//		Transaction transaction =s.beginTransaction();
		List<Term> terms =s.createCriteria(Term.class).add(Restrictions.sqlRestriction(sqlWhere)).list();
		s.close();
		return terms;
		
	}

	public List<Term> getTermsWithoutAccession(String tctName,Connection con) {
		Session s =HibernateUtil.getSession(con);
		Transaction transaction =s.beginTransaction();
		 List<Term>  terms= s.createCriteria(Term.class).add(Restrictions.eq("trmEdbacc","unreferenced")).createCriteria("trmCategory").add(
				Restrictions.eq("tctName", tctName)).list();
		 transaction.commit();
		 s.close();
		 
		 return terms;
	}

	/**
	 * Checks if there is a Term in DB which is equals to the given.
	 * @param term
	 * @return A new Term which maps to the DB Entry or NULL if no Term matchs.
	 */
	public Term checkOnNaturalID(Term term,Connection con) {
		Session s =HibernateUtil.getSession(con);
		Transaction tx =s.beginTransaction();

		String edbName ;
		if (term.getExterndb() == null)
			edbName ="unreferenced";
		else
			edbName = term.getExterndb().getEdbName();
		
		Term newTerm =null;
		newTerm = (Term)s.createCriteria(Term.class,"term").add(
				Restrictions.eq("trmValue", term.getTrmValue())).
				createCriteria("term.externdb").add(Restrictions.eq("edbName", edbName)).
				createCriteria("term.trmCategory").add(Restrictions.eq("tctName", term.getTrmCategory().getTctName())).
				setCacheable(true).uniqueResult();
		
		tx.commit();
		s.close();
		
		return newTerm;
	}	

}
